/**********************************************************************
* Copyright (C) 2012-2015 by www.appsolutions.com, and                * 
* other contributors as listed below.  All Rights Reserved.           *
*                                                                     *
*  Software is distributed on an "AS IS", WITHOUT WARRANTY OF ANY     *
*   KIND, either express or implied.                                  *
*                                                                     *
*  Contributors:                                                      *
**********************************************************************/ 
/*------------------------------------------------------------------------
   File        : Env
   Purpose     : Static environment class for accessing RTB event handle from non-static procedures.
   Syntax      : 
   Description :  
   Author(s)   : Thomas Hansen / appSolutions
   Created     : Wed May 29 16:21:29 CEST 2013
   Notes       : This class is only used to have a static class with an instance of scm.custom.rtb.CustomRtbEvents 
                 which gets shut down if the procedure or class starting it is not static or run presistently.   
 ----------------------------------------------------------------------*/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING scm.custom.rtb.* FROM PROPATH. 
USING scm.custom.rtb.client.* FROM PROPATH.
USING scm.custom.rtb.server.* FROM PROPATH.

CLASS scm.custom.rtb.Env: 

    DEFINE PUBLIC STATIC PROPERTY RTBProxyHelper AS scm.custom.rtb.Utils.RTBProxyHelper NO-UNDO
        GET():
            IF NOT VALID-OBJECT(RTBProxyHelper) THEN
                RTBProxyHelper = NEW scm.custom.rtb.Utils.RTBProxyHelper().

            RETURN RTBProxyHelper.
        END GET.
        PRIVATE SET.

    DEFINE PUBLIC STATIC PROPERTY TempTableHelper AS scm.custom.rtb.Utils.TempTableHelper NO-UNDO
        GET():
            IF NOT VALID-OBJECT(TempTableHelper) THEN
                TempTableHelper = NEW scm.custom.rtb.Utils.TempTableHelper().

            RETURN TempTableHelper.
        END GET.
        SET.

        PRIVATE SET.

END CLASS.
