&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" Procedure _INLINE
/* Actions: af/cod/aftemwizcw.w ? ? ? ? */
/* Version Notes Wizard
Check object version notes.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" Procedure _INLINE
/* Actions: ? ? ? ? af/sup/afverxftrp.p */
/* This has to go above the definitions sections, as that is what it modifies.
   If its not, then the definitions section will have been saved before the
   XFTR code kicks in and changes it */
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" Procedure _INLINE
/* Actions: ? af/cod/aftemwizcw.w ? ? ? */
/* Program Definition Comment Block Wizard
Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure
/*********************************************************************
* Copyright (C) 2006-2016 by Roundtable Software Inc. ("Roundtable"),*
*  All Rights Reserved.                                              *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
* nodeable limited (www.nodeable.io)                                 *
*********************************************************************/

/*---------------------------------------------------------------------------------
  File: ryrtbevntp.p

  Description:  Roundtable events API hook

  Purpose:      This procedure will be run automatically from Roundtable when any event is
                fired within _idertb_events.p

  Parameters:

  History:
  --------
  (v:010001)    Task:           2   UserRef:    Issue 8482
                Date:   02/13/2003  Author:     Thomas Hansen

  Update Notes: 05/02/03 thomas:
                - Added code to show additional information to the user when assigning objects.
                - Added generic log capabilities and added sue of this to the import events
                - Added support for new RTB events for RTB 9.1C02

  (v:010002)    Task:          20   UserRef:
                Date:   03/06/2003  Author:     Thomas Hansen

  Update Notes: Issue 8696 : Module Load of DynObjc generate .edo?

  (v:010003)    Task:          26   UserRef:
                Date:   03/11/2003  Author:     Thomas Hansen

  Update Notes: Issue 7361:
                - fixed bug where object checkin was not deletnig actionUnderWay records.
                - changed some of the formatting of the object-checkin and object-checkin-befor eprocedures.

  (v:010004)    Task:    93000004   UserRef:
                Date:   02/28/2007  Author:     Thomas Hansen

  Update Notes: [Object checked out] 02/28/07 thomas:
                Fix RV and RTB objects, to allow single r-code set

  (v:010005)    Task:    90000021   UserRef:
                Date:   02/12/2002  Author:     Dynamics Admin User

  Update Notes: Remove RVDB dependency

  (v:010006)    Task:    93000005   UserRef:
                Date:   03/02/2007  Author:     System Operator

  Update Notes: [Object checked out] 03/02/07 08:25 thomas:
                Fixed problem with incorrect RTB session shutdown for non-AppServer sesssion in plipShutdown.

  (v:020000)    Task:          31   UserRef:
                Date:   03/25/2003  Author:     Thomas Hansen

  Update Notes: Issue 9648 :
                - Checked handling of object extensions for events regarding processing of objects in ICFDB
                - Removed auto-create of .ado file at cehck-out as this is not necessary

  (v:030000)    Task:          42   UserRef:
                Date:   05/04/2003  Author:     Thomas Hansen

  Update Notes: Issue 8346:
                Fixed removal of actionUnderWay record to correctly remove the record after custom variants have been created.

  (v:040000)    Task:          50   UserRef:
                Date:   05/27/2003  Author:     Thomas Hansen

  Update Notes: 05/27/2003 thomas:
                Issue 10741: Updated manager API call to afmessagep

  (v:040001)    Task:          52   UserRef:
                Date:   06/03/2003  Author:     Thomas Hansen

  Update Notes: Delete should only apply to PCODE objects

  (v:050001)    Task:    11000295   UserRef:
                Date:   01/07/2005  Author:     Thomas Hansen

  Update Notes: [Object checked out] 06/17/04 17:19 thomas :
                Replaced all references to Grtb- variables to use new RTB calls and events.

                Updated all the event names to be compliant with RTB 9.1D.

                Replaced all instances of RECID with ROWID, as this is used in RTB 9.1D now.

                Replaced all instances of INTEGER(pcContext) with TO-ROWID(pcContext).

                Added support for nonDynamics Objects not being replicated or prompted for export of .ado data.

  (v:050002)    Task:    11000359   UserRef:
                Date:   13/05/2005  Author:     Thomas Hansen

  Update Notes: [Object checked out] 22/03/05 19:54 thomas :

  (v:050004)    Task:    11000396   UserRef:
                Date:   07/07/2005  Author:     Thomas Hansen

  Update Notes: [Object checked out] 07/07/05 10:17 thomas:
                Update event handler code to support APIs being run from batch.

  (v:030004)    Task:    33002015   UserRef:
                Date:   13/03/2006  Author:     Thomas Hansen

  Update Notes: [Object checked out] 13/03/06 13:53 sysop :
                Added code to allow users to run a selective compile at the end of the import process.

  (v:050005)    Task:    11000713   UserRef:
                Date:   09/21/2006  Author:     System Operator User

  Update Notes: [Object checked out] 09/21/06 14:30 thomas :
                Add event to prevent check out of objects in non-PRIMary workspaces.

  (v:050006)    Task:    11000733   UserRef:
                Date:   11/28/2006  Author:     System Operator User

  Update Notes: [Object checked out] 11/28/06 10:28 sysop :

  (v:050007)    Task:    11000738   UserRef:
                Date:   12/20/2006  Author:     Thomas Hansen

  Update Notes: [Object checked out] 12/20/06 08:49 thomas :
                Replaced references to AD code in rtb/prc to ad/prc

  (v:020001)    Task:    11000745   UserRef:
                Date:   05/02/2007  Author:     Thomas Hansen

  Update Notes: [Object checked out] 02/25/07 21:18 thomas :

  (v:050009)    Task:    11000819   UserRef:
                Date:   06/26/2007  Author:     System Operator User

  Update Notes: [Object checked out] 06/26/07 11:08 thomas:
                Added support for creating rtbdeploy.props file with deployment properties for ant script processing.

  (v:020002)    Task:    11000745   UserRef:
                Date:   08/16/2007  Author:     System Operator User

  Update Notes: [Object checked out] 05/02/07 15:09 sysop :

  (v:030001)    Task:    11000882   UserRef:
                Date:   01/11/2008  Author:     System Operator User

  Update Notes: [Object checked out] 01/11/08 13:24 thomas :
                Update with changes to deplcoyment control file creation in AD.

  (v:030002)    Task:    11000887   UserRef:
                Date:   02/15/2008  Author:     System Operator User

  Update Notes: [Object checked out] 02/15/08 11:53 sysop :

  (v:060000)    Task:
                Date:   24/09/2015  Author:     Thomas Hansen

  Update Notes: Updated code to get object name from first entry of pcOther parameter.

----------------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
/* MIP-GET-OBJECT-VERSION pre-processors
   The following pre-processors are maintained automatically when the object is
   saved. They pull the object and version from Roundtable if possible so that it
   can be displayed in the about window of the container */

&SCOPED-DEFINE object-name       ryrtbevntp.p
DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.
&SCOPED-DEFINE object-version    060000

DEFINE VARIABLE cObjectName         AS CHARACTER NO-UNDO.
ASSIGN
    cObjectName                 = "{&object-name}":U
    THIS-PROCEDURE:PRIVATE-DATA = "ryrtbevntp.p":U.

/* MIP object identifying preprocessor */
&GLOBAL-DEFINE   mip-structured-procedure    YES

DEFINE STREAM ls_output.

/*{rtb/i/rtb_super.i}*/

{src/adm2/globals.i}
{launch.i   &Define-only = YES}
{checkerr.i &Define-only = YES}

/* Add the OEIDE include to check if we are running from eclipse */
{adecomm/oeideservice.i}

DEFINE VARIABLE gcRtbCurrentWorkspace     AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcRtbCurrentUser          AS CHARACTER NO-UNDO.
DEFINE VARIABLE giRTBCurrentTaskNum       AS INTEGER   NO-UNDO.
DEFINE VARIABLE gcRtbCurrentWorkspacePath AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcRtbCurrentWorkspaceRoot AS CHARACTER NO-UNDO.
DEFINE VARIABLE giRTBSid                  AS INTEGER   NO-UNDO.
DEFINE VARIABLE gcRTBASConnectString      AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcRTBASConnectURL         AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcRtbCurrentUserPassword  AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcASHostName              AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcASPort                  AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcASService               AS CHARACTER NO-UNDO.

/* Common variables used for displaying Dynamics type messages */
DEFINE VARIABLE cMesWinTitle              AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMesWinMessage            AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMesWinButtonList         AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMesWinButtonDefault      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMesWinButtonCancel       AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMesWinAnswerValue        AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMesWinAnswerDataType     AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMesWinAnswerFormat       AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMesWinButtonPressed      AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcNonDynamicObjectTypes   AS CHARACTER NO-UNDO.

ASSIGN
    gcNonDynamicObjectTypes = "ABLClass,ABLForm,ABLInterface,AccessDB,AVI,BatFile,BMP,ChmFile,CldFile,CntFile,Crystal,CrystalData,CstFile,CUR,Cvs,Data,DataDef,DataDump,DataSet,DatFile,DB,DllFile,Documents,ErrFile,ERWin Model,ERWin Templt,Excel,Filter,GidFile,GIF,Help,hhcFile,hhpFile,HTACCESS,htaFile,HTC,HTM,HTML,ICO,Icon,Include,IniFile,JavaScript,JPG,LibFile,Lnk File,OcxFile,PatchFileLst,PfFile,PGEN,PowerPoint,PrintLib,ProcNonDyn,Project,properties,RtfFile,Shell,StyleSheet,Template,Text,TIF,TVController,VbpFile,VbwFile,Visio,WAV,Xml,XSL,xsd,bedgm,png,misc,PDSInclude,templatefile,json".

DEFINE VARIABLE ghRtbAs                 AS HANDLE                               NO-UNDO.
DEFINE VARIABLE hFileIO                 AS HANDLE                               NO-UNDO.
DEFINE VARIABLE glShowNotifyBallonTips  AS LOGICAL                              NO-UNDO INITIAL TRUE.
DEFINE VARIABLE glDebug                 AS LOGICAL                              NO-UNDO INITIAL FALSE.
DEFINE VARIABLE gcRtbVersion            AS CHARACTER                            NO-UNDO.
DEFINE VARIABLE gcAssignObjectName      AS CHARACTER                            NO-UNDO.
DEFINE VARIABLE gcAssignObjectType      AS CHARACTER                            NO-UNDO.
DEFINE VARIABLE gcAssignProductModule   AS CHARACTER                            NO-UNDO.
DEFINE VARIABLE gcAssignObjectVersion   AS CHARACTER                            NO-UNDO.

DEFINE VARIABLE gcVersionNotesTemplate  AS CHARACTER                            NO-UNDO.
DEFINE VARIABLE gcDefaultManagerList    AS CHARACTER                            NO-UNDO.
DEFINE VARIABLE gcDefaultProgrammerList AS CHARACTER                            NO-UNDO.
DEFINE VARIABLE oRtbProxyHelper         AS scm.custom.rtb.Utils.RTBProxyHelper  NO-UNDO.
DEFINE VARIABLE oTempTableHelper        AS scm.custom.rtb.Utils.TemptableHelper NO-UNDO.

/*
ASSIGN
    gcVersionNotesTemplate = "Help Desk notes:~n" +
                              "<Enter valid version notes>~n" +
                              "Technical notes:~n" +
                              "<Enter valid version notes>~n" +
                              "General User notes:~n" +
                              "<Enter valid version notes>".
*/ 

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Prototypes ********************** */


&IF DEFINED(EXCLUDE-getTimeStampString) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getTimeStampString Version
FUNCTION getTimeStampString RETURNS CHARACTER
    (INPUT pcEvent       AS CHARACTER,
    INPUT pcWorkspaceid AS CHARACTER,
    INPUT pcRtbUserId   AS CHARACTER) FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF




/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow:
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB)
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 33.67
         WIDTH              = 69.6.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME




&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure


/* *************************** Main Block  *************************** */
/* Subscribe to new custom events */
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetWorkspaceRoot":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustSetWorkspaceRoot":U ANYWHERE.

SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetWorkspacePath":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustSetWorkspacePath":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetShowNotifyBallonTips":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "ChangeWorkspace":U ANYWHERE.

SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetDebug":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustSetDebug":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustSetRTBASHandle":U ANYWHERE.

/* subcribe to the events that usually come from RTB */
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbGetCurrentTask":U      ANYWHERE.

SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "ICFSTART_BeforeInitialize":U ANYWHERE.

{ry/app/ryplipmain.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-addObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE addObject Procedure

PROCEDURE addObject :
    /*------------------------------------------------------------------------------
          Purpose:     After object is added
          Parameter :  pcContext       : STRING value of ROWID of the Brtb_object table
          / Meaning :  pcOther         : Object name
                       pcErrorMessage : ignored

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lActionUnderway     AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE hObjectData         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjectBuf          AS HANDLE    NO-UNDO.   
    DEFINE VARIABLE hVerData            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cVersionUpdateNotes AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectName         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectType         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cPmod               AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspaceId        AS CHARACTER NO-UNDO.

    ASSIGN
        cObjectName  = ENTRY(1, pcOther)
        cObjectType  = ENTRY(2, pcOther)
        cPmod        = ENTRY(3, pcOther)
        cWorkspaceId = ENTRY(4, pcOther).
    /* Start : Time Stamping*/

    oRtbProxyHelper:custRtbSetVerUpdNotes (
        INPUT pcContext,
        INPUT SUBSTITUTE("[Object created] &1 &2:~n&3", STRING(NOW, "99/99/9999 HH:MM:SS+HH:MM":U), gcRtbCurrentUser, gcVersionNotesTemplate),
        INPUT FALSE,
        INPUT "*[Object created]").
    /* End: Time Stamping*/

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "DYN":U,
            INPUT  "ANY":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).

    IF lActionUnderway = YES THEN
        RETURN.

    hObjectData = oRtbProxyHelper:rtbGetObjectByRowidHandle(pcContext).

    hObjectBuf = hObjectData:DEFAULT-BUFFER-HANDLE.
    hObjectBuf:FIND-FIRST() NO-ERROR.  

    /* We are not interested in objects that are not dynamic objects here. */
    /* Also, we do not want to be overwriting DataSet objects with the automated .ado file generation */
    IF VALID-HANDLE(hObjectData) THEN 
    DO:
        /* Get object version details */       
        hVerData = oRtbProxyHelper:rtbgetVersionHandle(
            INPUT hObjectBuf::obj-type,
            INPUT hObjectBuf::object,
            INPUT hObjectBuf::pmod,
            INPUT hObjectBuf::version).
        hVerBuf = hVerData:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        /* We are not interested in objects that are not dynamic objects here. */
        /* Also, we do not want to be overwriting DataSet objects with the automated .ado file generation */
        IF hVerBuf:AVAILABLE AND
            (hVerBuf::obj-type = "PCODE":U AND
            LOOKUP(hVerBuf::sub-type, gcNonDynamicObjectTypes) = 0) THEN
            RUN scmHookCreateObject (
                INPUT  gcRtbCurrentWorkspace,
                INPUT  giRtbCurrentTaskNum,
                INPUT  gcRtbCurrentUser,
                INPUT  cObjectName,
                INPUT  hVerBuf::pmod,
                OUTPUT pcErrorMessage).
        IF pcErrorMessage = "":U THEN
            IF glShowNotifyBallonTips THEN  
                PUBLISH "showNotifyBallonTip" ("":U, SUBSTITUTE("Object '&1' created in Dynamics.", cObjectName), 50).
    END.

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "ADD":U,
            INPUT  cObjectName,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

    IF pcErrorMessage <> "":U THEN
        RETURN.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.

    RETURN.

    FINALLY:
        /* Clean up */
        IF VALID-HANDLE(hObjectData) THEN 
            DELETE OBJECT hObjectData.

        IF VALID-HANDLE(hVerData) THEN
            DELETE OBJECT hVerData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-addObjectBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE addObjectBefore Procedure
PROCEDURE addObjectBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before object is added
          Parameters :  Pcontext = ""
                        Pother   = Object Name, Object Type, Product Module, Workspace ID
                        Pok      = False will cancel
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lActionUnderway AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cMessage        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectName     AS CHARACTER NO-UNDO.

    ASSIGN 
        cObjectName = ENTRY(1, pcOther). 

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "DYN":U,
            INPUT  "ANY":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).

    IF lActionUnderway = YES THEN 
        RETURN.

    /* Check if the object being created is an alised object - if it is, cancecl the create as we cannot support this 
       for Dynamics objects     
     */
    IF cObjectName BEGINS "@":U THEN
    DO:
        ASSIGN 
            cMessage = "Aliased objects are not supported by Dynamics. ~n":U +
                    "You should therefore not create aliased objects for objects of a code subtype that will ~n":U +
                    "be replicated to Dynamics. ~n~n":U +
                    "You should only continue the object creation if the object you are creating will not be ~n":U +
                    "replicated to the Dynamics repository.~n~n":U +
                    "Do you want to continue creating the object?".

        MESSAGE cMessage
            VIEW-AS ALERT-BOX WARNING
            BUTTONS YES-NO
            UPDATE lContinue AS LOGICAL.

        IF NOT lContinue THEN
        DO:
            ASSIGN
                pcErrorMessage = "Aliased object creation cancelled".
            RETURN.
        END.

    END.

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN setActionUnderway IN gshSessionManager
            (INPUT "SCM":U,
            INPUT "ADD":U,
            INPUT cObjectName,
            INPUT "":U,
            INPUT "":U).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-addObjectUI) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE addObjectUI Procedure
PROCEDURE addObjectUI :
    /*------------------------------------------------------------------------------
                Purpose:
                Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectName AS CHARACTER NO-UNDO.
    
    ASSIGN 
        cObjectName = ENTRY(1, pcOther). 
    
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-assignObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE assignObject Procedure
PROCEDURE assignObject :
    /*------------------------------------------------------------------------------
          Purpose:     After object is assigned
          Parameter :  pcContext       : STRING value of ROWID of the rtb_object table
          / Meaning :  pcOther         : Object name
                       pcErrorMessage : ignored

       Notes:       The parameters do not work here so we must use the saved variables
                    set-up during the before assign hook.
                    If we get here, the assign must have worked anyway.

                    An object assignment occurs whenever an object version is manually assigned
                    between workspaces, an object import is done, or an object version is deleted
                    in favour of a previous version.
                    See notes in code for further explanation.

                    Also needs to deal with regeneration of repository object data via xml file.

     ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lActionUnderway   AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lImportUnderway   AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lSuppressMessages AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cReturnCharacter  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cMessage          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hObjectData       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjectBuf        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cObjectName       AS CHARACTER NO-UNDO.

    /*   We only want to handle events for PCODE objects, if the         */
    /*   object is not a PCODE object, then cancel the extension to this */
    /*   event by returning.                                             */
    IF pcContext = ?  THEN
        RETURN.

    IF NUM-ENTRIES (pcOther) > 1 THEN
        ASSIGN
            cObjectName = ENTRY(1, pcOther).
    ELSE
        ASSIGN
            cObjectName = pcOther.

    hObjectData = oRtbProxyHelper:rtbGetObjectByRowidHandle(pcContext).

    hObjectBuf = hObjectData:DEFAULT-BUFFER-HANDLE.
    hObjectBuf:FIND-FIRST() NO-ERROR.

    /* If this is not a PCODE object, or if the object does not need and additional Dynamics processing */
    /* then just get rid of any actionUnderway records there may be and RETURN                          */
    IF hObjectBuf::obj-type NE "PCODE":U THEN
    DO:
        /* Remove and actionUnderWay records that may have been created for this event.  */
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "ASS":U,
            INPUT  cObjectName,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).
        RETURN.
    END.

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "DYN":U,
            INPUT  "ANY":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).
    IF lActionUnderway = YES THEN
        RETURN.

    /* Inform the user that additional processing is being done. */
    ASSIGN
        cMessage = "Processing Dynamics Assign Object extensions for " + hObjectBuf::Object + " ...".
    PUBLISH "evRtbSetStatusMessage":U (INPUT cMessage).

    RUN scmHookAssignObject (
        INPUT gcRtbCurrentWorkspace,
        INPUT giRTBCurrentTaskNum,
        INPUT gcRtbCurrentUser,
        INPUT hObjectBuf::Object,
        INPUT hObjectBuf::obj-type,
        INPUT hObjectBuf::Pmod,
        INPUT INTEGER(hObjectBuf::VERSION),
        OUTPUT pcErrorMessage).

    /* If there are error messages from the assign process,
       we should write these to the log if we are inthe process of importing */

    /* First check if we are in the process of importing.
       If we are not importing, then we do not want to log the event, as
       this is not all that useful. The collection of assign changes that '
       are made during the import process are much more useful.
    */
    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "IMPORT":U,
            INPUT  gcRtbCurrentWorkspace,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lImportUnderway).

    IF lImportUnderWay THEN
    DO:
        PUBLISH "logEvent" (
            INPUT pcEvent,
            INPUT "[":U + STRING(TIME, "HH:MM":U) + "] ":U + pcEvent + " - ":U + cObjectName,
            INPUT "INF":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT gcRtbCurrentUser,
            INPUT "LOG":U,
            INPUT "dynrtb_import.log",
            INPUT "":U) .

        IF pcErrorMessage <> "":U THEN
            PUBLISH "logEvent" (
                INPUT pcEvent,
                INPUT "ERROR / ":U + pcEvent + " (":U + cObjectName + ") : ":U + pcErrorMessage,
                INPUT "ERROR":U,
                INPUT gcRtbCurrentWorkspace,
                INPUT gcRtbCurrentUser,
                INPUT "LOG,STATUS":U,
                INPUT "dynrtb_import.log",
                INPUT "":U) .
        /* If we are suppressing error messages then reset the error message -
           as we do not want this displaying in the process-event procedure
           afterwards
        */
        cReturnCharacter =  DYNAMIC-FUNCTION("getPropertyList":U IN gshSessionManager,
            INPUT "SuppressMessages":U,
            INPUT YES).

        IF cReturnCharacter = "YES" THEN
            ASSIGN lSuppressMessages = TRUE.
        ELSE
            ASSIGN lSuppressMessages = FALSE.

        IF lSuppressMessages THEN
            ASSIGN pcErrorMessage = "":U.
    END.   /* IF lImportUnderWay ...*/

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "ASS":U,
            INPUT  cObjectName,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

    /* Reset the status default to get rid of the additional processing message */
    STATUS DEFAULT "":U.

    IF pcErrorMessage <> "":U THEN
        RETURN.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hObjectData) THEN
            DELETE OBJECT hObjectData.

    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-assignObjectBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE assignObjectBefore Procedure
PROCEDURE assignObjectBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before object is assigned
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Object name, Object type, Product Module, Version
                       pcErrorMessage : non blank will cancel

          Notes:       Set-up object being assigned as after assign hook parameters do not work.
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcErrorMessage      AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lActionUnderway AS LOGICAL NO-UNDO.

    IF VALID-HANDLE(gshSessionManager)
        THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "DYN":U,
            INPUT  "ANY":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).

    IF lActionUnderway = YES THEN
        RETURN.

    ASSIGN
        gcAssignObjectName    = ENTRY(1, pcOther)
        gcAssignObjectType    = ENTRY(2, pcOther)
        gcAssignProductModule = ENTRY(3, pcOther)
        gcAssignObjectVersion = ENTRY(4, pcOther).

    IF VALID-HANDLE(gshSessionManager)
        THEN
        RUN setActionUnderway IN gshSessionManager
            (INPUT "SCM":U,
            INPUT "ASS":U,
            INPUT gcAssignObjectName,
            INPUT "":U,
            INPUT "":U).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-beforeChangeWorkspace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE beforeChangeWorkspace Procedure
PROCEDURE beforeChangeWorkspace :
    /*------------------------------------------------------------------------------
          Purpose:     Before changed workspace
          Parameter :  pcContext       : STRING(Grtb-proc-handle) (Roundtable procedure handle)
          / Meaning :  pcOther         : String value of the name of the workspace that was selected.
                       pcErrorMessage : ignored

          Notes:       This hook should not fire custom code off.

                       Nothing happens in this hook apart from shutdown,
                       which happens in rtb_evnt.p.

            ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-buildImportList) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE buildImportList Procedure
PROCEDURE buildImportList :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters:   Pcontext = blank
                        Pother   = Target Workspace

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-buildImportListBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE buildImportListBefore Procedure
PROCEDURE buildImportListBefore :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters:   Pcontext = blank
                        Pother   = Target Workspace
                        Pok      = False will cancel
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-buildSchemaList) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE buildSchemaList Procedure
PROCEDURE buildSchemaList :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters: Pcontext = blank
                      Pother   = Database Name
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-changeObjectShareStatus) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE changeObjectShareStatus Procedure
PROCEDURE changeObjectShareStatus :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters:   pcEvent          :   "changeObjectShareStatus",
                    pcContext        :   String value of ROWID for rtb.Brtb_object
                    pcOther          :   Object, Old status, New Status, Workspace Path, Task Path
                    ip_error_message  :   Ignored
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-changeObjectShareStatusBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE changeObjectShareStatusBefore Procedure
PROCEDURE changeObjectShareStatusBefore :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters: pcEvent     :   "changeObjectShareStatusBefore",
                      pcContext   :   String value of ROWID for rtb.Brtb_object
                      pcOther     :   Object, Old status, New Status, Workspace Path, Task Path
                      ip_ok        :   Cancel if false
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-changePropath) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE changePropath Procedure
PROCEDURE changePropath :
    /*------------------------------------------------------------------------------
          Purpose:    After propath change
          Parameter : pcContext       : ROWID (table depends on context)
          / Meaning : pcOther         : context (see note)
                      pcErrorMessage : Cancel load if FALSE

          Notes:      Possible "other" and "context" values include

                          p_other     - BEFORE-COMPILE
                          p_context   - ROWID is rtb_object to be compiled.
                                        It is not perfect as the workspace path is stripped
                                        from the ProPath before this hook is fired.

                          p_other     - AFTER-COMPILE
                          p_context   - ROWID is rtb_object that was compiled

                          p_other     - BEFORE-XREF
                          p_context   - ROWID is rtb_object that was compiled

                          p_other     - AFTER
                          p_context   - ROWID is rtb_object that was compiled

        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-changePropathBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE changePropathBefore Procedure
PROCEDURE changePropathBefore :
    /*------------------------------------------------------------------------------
          Purpose:    Before propath change
          Parameter : pcContext       : ROWID (table depends on context)
          / Meaning : pcOther         : context (see note)
                      pcErrorMessage : Cancel load if FALSE

          Notes:      Possible "other" and "context" values include

                          p_other     - BEFORE-COMPILE
                          p_context   - ROWID is rtb_object to be compiled.
                                        It is not perfect as the workspace path is stripped
                                        from the ProPath before this hook is fired.

                          p_other     - AFTER-COMPILE
                          p_context   - ROWID is rtb_object that was compiled

                          p_other     - BEFORE-XREF
                          p_context   - ROWID is rtb_object that was compiled

                          p_other     - AFTER
                          p_context   - ROWID is rtb_object that was compiled

        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-changeTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE changeTask Procedure
PROCEDURE changeTask :
    /*------------------------------------------------------------------------------
          Purpose:     After changed task
          Parameter :  pcContext       : STRING(Grtb-proc-handle) (Roundtable procedure handle)
          / Meaning :  pcOther         : String value of the task that was selected.
                       pcErrorMessage : ignored

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    /* Set the currently selecte dtask number as an SCM session parameter  */
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "_scm_current_task_number":U, pcOther ) NO-ERROR.

    ASSIGN
        giRtbCurrentTaskNum = INTEGER(pcOther).

    IF glShowNotifyBallonTips THEN
        PUBLISH "showNotifyBallonTip" ("":U, SUBSTITUTE("Task set to: &1...", giRtbCurrentTaskNum), 50).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-changeWorkspace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE changeWorkspace Version
PROCEDURE changeWorkspace:
    /*------------------------------------------------------------------------------
          Purpose:     After changed workspace
          Parameter :  pcContext       : STRING(Grtb-proc-handle) (Roundtable procedure handle)
          / Meaning :  pcOther         : String value of the name of the workspace that was selected.
                       pcErrorMessage : ignored

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cWorkspaceServerPath AS CHARACTER NO-UNDO.

    ASSIGN
        gcRtbCurrentWorkspace = pcOther.

    /* Get the workspace paths */
    oRtbProxyHelper:custGetWorkspacePaths(
        INPUT  gcRtbCurrentWorkspace,
        OUTPUT gcRtbCurrentWorkspacePath,
        OUTPUT cWorkspaceServerPath,
        OUTPUT gcRtbCurrentWorkspaceRoot).

    PUBLISH "evRtbCustSetWorkspacePath" (INPUT gcRtbCurrentWorkspacePath).
    PUBLISH "evRtbCustSetWorkspaceRoot" (INPUT gcRtbCurrentWorkspaceRoot).

    /* Set the workspace Root as an SCM session parameter */
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "_scm_root_directory":U, gcRtbCurrentWorkspaceRoot) NO-ERROR.

    /* Set the relative source code directory as an SCM session parameter */
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "_scm_relative_source_directory":U, "src/icf":U) NO-ERROR.

    /* Set the Currently Selected workspace as an SCM session parameter  */
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "_scm_current_workspace":U, gcRtbCurrentWorkspace ) NO-ERROR.

    IF glShowNotifyBallonTips THEN
        PUBLISH "showNotifyBallonTip" (SUBSTITUTE("RTB Dynamics - &1", gcRtbCurrentWorkspace), SUBSTITUTE("Workspace changed to &1.", gcRtbCurrentWorkspace), 2000).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF

&IF DEFINED(EXCLUDE-checkDynamicObjectPaths) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE checkDynamicObjectPaths Procedure
PROCEDURE checkDynamicObjectPaths :
    /*------------------------------------------------------------------------------
              Purpose: Check if the object paths have incorrect **src paths
              Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcObjectName  AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER pcPathPrefix  AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cRepoObjectName AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dSmartobjectObj AS DECIMAL   NO-UNDO.

    RUN getRepoObjectName (
        INPUT  pcObjectName,
        OUTPUT cRepoObjectName,
        OUTPUT dSmartobjectObj).

    IF cRepoObjectName = "":U AND
        dSmartobjectObj NE 0 THEN
        RETURN.

    /* Check the object's own path */
    FIND FIRST ryc_smartobject EXCLUSIVE-LOCK WHERE
        ryc_smartobject.smartobject_obj = dSmartobjectObj NO-ERROR.
    IF AVAILABLE ryc_smartobject THEN
    DO:
        IF ryc_smartobject.object_path BEGINS pcPathPrefix THEN
            ASSIGN ryc_smartobject.object_path = REPLACE(OBJECT_path, pcPathPrefix, "":U).

        /* Check all the attributes where the path may be in play... */
        FOR EACH ryc_attribute_value EXCLUSIVE-LOCK WHERE
            ryc_attribute_value.smartobject_obj = ryc_smartobject.smartobject_obj:
            IF ryc_attribute_value.character_value BEGINS pcPathPrefix THEN
                ASSIGN
                    ryc_attribute_value.character_value = REPLACE(ryc_attribute_value.character_value, pcPathPrefix, "").
        END.
    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-checkinObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE checkinObject Procedure
PROCEDURE checkinObject :
    /*------------------------------------------------------------------------------
          Purpose:     After object is checked in
          Parameter :  Pcontext = rtb_object ROWID string value
                       PcOther  = Object Name, Object Type, Product Module, Workspace ID
                       pcErrorMessage : ignored

          Notes:

          ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cErrorText          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lActionUnderway     AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cVersionUpdateNotes AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectName         AS CHARACTER NO-UNDO.

    IF NUM-ENTRIES (pcOther) > 1 THEN 
        ASSIGN 
            cObjectName = ENTRY(1, pcOther). 
    ELSE
        ASSIGN 
            cObjectName = pcOther. 

    IF VALID-HANDLE(gshSessionManager) THEN 
    DO:
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "TASKCOMP":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).
                         
        IF lActionUnderway = NO THEN 
        DO:
            RUN getActionUnderway IN gshSessionManager (
                INPUT  "SCM":U,
                INPUT  "SKIPDUMPYES":U,
                INPUT  cObjectName,
                INPUT  "":U,
                INPUT  "":U,
                INPUT  YES,
                OUTPUT lActionUnderway).

            RUN getActionUnderway IN gshSessionManager (
                INPUT  "SCM":U,
                INPUT  "SKIPDUMPNO":U,
                INPUT  cObjectName,
                INPUT  "":U,
                INPUT  "":U,
                INPUT  YES,
                OUTPUT lActionUnderway).

        END. /* lActionUnderway = NO */
    END. /* VALID-HANDLE(gshSessionManager) */

    /* Start - Time Stamping*/
    ASSIGN
        cVersionUpdateNotes = getTimeStampString(pcEvent, gcRtbCurrentWorkspace, gcRtbCurrentUser).

    oRtbProxyHelper:custRtbSetVerUpdNotes (pcContext, cVersionUpdateNotes, TRUE, "*[Object checked in]*").
    /* End - Time Stamping*/

    /* The following code will clean up the actionUnderway table and also
      re-enable the replication triggers - which may have been
      disabled in scmHookMoveModule in rtb/prc/ryscmevntp.p
    */
    ASSIGN
        cObjectName = IF NUM-ENTRIES(pcOther) > 1 THEN ENTRY(1, pcOther) ELSE pcOther
        cObjectName = REPLACE(cObjectName,".ado":U,"":U).

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "ASS":U,
            INPUT  cObjectName,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

    CATCH err AS Progress.Lang.Error :
        ASSIGN
            pcErrorMessage = err:GetMessage(1).
    END CATCH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-checkInObjectBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE checkInObjectBefore Procedure
PROCEDURE checkInObjectBefore :
    /* ------------------------------------------------------------------------------
        Purpose:     Before object is checked in
          Parameter :  pcContext       : STRING value of ROWID of the Brtb_object table
                       Pother   = Object Name, Object Type, Product Module, Workspace ID
                       Pok      = False will cancel
                         pcErrorMessage : non blank will cancel check in

          Notes:       Do preliminary checking and abort object check in if details
                       cannot be found that will be required after the check in to
                       update the Dynamics task object table.
                       Belt and braces really !
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cButton         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cErrorText      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lActionUnderway AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE hVerData        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE lExport         AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE iVerTaskNum     AS INTEGER   NO-UNDO.
    DEFINE VARIABLE hData           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hBuf            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cObjectName     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectType     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cPmod           AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspaceID    AS CHARACTER NO-UNDO.

    ASSIGN
        cObjectName  = ENTRY(1, pcOther)
        cObjectType  = ENTRY(2, pcOther)
        cPmod        = ENTRY(3, pcOther)
        cWorkspaceID = ENTRY(4, pcOther).

    hData = oRtbProxyHelper:rtbGetObjectByRowidHandle(pcContext).

    hBuf = hData:DEFAULT-BUFFER-HANDLE.
    hBuf:FIND-FIRST() NO-ERROR.

    IF NOT hBuf:AVAILABLE OR
        hBuf::object <> cObjectName THEN
    DO:
        IF VALID-HANDLE(gshSessionManager) THEN
        DO:
            RUN showMessages IN gshSessionManager
                (INPUT {af/sup2/aferrortxt.i 'AF' '36' '?' '?' "'Progress Dynamics'" "'the Brtb_object record could not be found or the wrong object was found from the ROWID'"},
                INPUT "ERR":U,
                INPUT "OK":U,
                INPUT "OK":U,
                INPUT "OK":U,
                INPUT "RTB Error",
                INPUT YES,
                INPUT ?,
                OUTPUT cButton).
        END.
        ELSE
        DO:
            MESSAGE
                "The update of data failed because the Brtb_object record could not be found or the wrong object was found from the ROWID"
                VIEW-AS ALERT-BOX WARNING BUTTONS OK.
        END.
        ASSIGN
            pcErrorMessage = "error":U.
        RETURN.
    END.

    IF hBuf::obj-type NE "PCODE":U THEN
        RETURN. /* only interested in pcode objects */

    /* Get object version details */
    hVerData = oRtbProxyHelper:rtbgetVersionHandle(
        INPUT hBuf::obj-type,
        INPUT hBuf::object,
        INPUT hBuf::pmod,
        INPUT hBuf::VERSION).

    hVerBuf = hVerData:DEFAULT-BUFFER-HANDLE.
    hVerBuf:FIND-FIRST() NO-ERROR.

    IF NOT hVerBuf:AVAILABLE THEN
    DO:
        IF VALID-HANDLE(gshSessionManager) THEN
            RUN showMessages IN gshSessionManager
                (INPUT {af/sup2/aferrortxt.i 'AF' '36' '?' '?' "'Progress Dynamics'" "'the Brtb_ver record could not be found'"},
                INPUT "ERR":U,
                INPUT "OK":U,
                INPUT "OK":U,
                INPUT "OK":U,
                INPUT "RTB Error",
                INPUT YES,
                INPUT ?,
                OUTPUT cButton).
        ELSE
            MESSAGE
                "The update of data failed because the Brtb_ver record could not be found"
                VIEW-AS ALERT-BOX WARNING BUTTONS OK.

        ASSIGN
            pcErrorMessage = "error":U.
        RETURN.
    END.

    /* Start : Time Stamping*/
    IF hVerBuf::upd-notes = "":U THEN
    DO:
        ASSIGN
            cErrorMessage = "Object " + hVerBuf::object + " does not have version notes. ~n" +
                            "You must enter version notes before you can check it in.~n~n" +
                            "Please ensure that the entered version notes are as relevant and as detailed as possible~n" +
                            "to ensure maximum benefit for others reading the notes.".

        RUN showMessages IN gshSessionManager (
            INPUT  cErrorMessage,    /* message to display */
            INPUT  "ERR":U,          /* error type */
            INPUT  "&OK":U,    /* button list */
            INPUT  "&OK":U,           /* default button */
            INPUT  "":U,       /* cancel button */
            INPUT  "Roundtable Version Notes Missing":U,             /* error window title */
            INPUT  YES,              /* display if empty */
            INPUT  ?,                /* container handle */
            OUTPUT cButton).           /* button pressed */

        ASSIGN
            pcErrorMessage = "No version notes".
        RETURN.
    END.
    /* End : Time Stamping*/

    /* We are not interested in objects that are not dynamic objects here. */

    /* Also, we do not want to be overwriting DataSet objects with the automated .ado file generation */
    IF hVerBuf:AVAILABLE AND
        (hVerBuf::obj-type = "PCODE":U AND
        LOOKUP(hVerBuf::sub-type, gcNonDynamicObjectTypes) > 0) THEN
        RETURN. /* We don't want to be overwriting DataSet objects*/
    ELSE
        ASSIGN iVerTaskNum = hVerBuf::task-num.

    IF VALID-HANDLE(gshSessionManager) THEN
    DO:
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "TASKCOMP":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).

        IF lActionUnderway = NO THEN
        DO:
            ASSIGN
                cMesWinTitle = "Object Check-In (Dynamics Enhancement)":U.

            ASSIGN
                cMesWinMessage = 'Do you wish to automatically export the objects information from the Progress Dynamics repository (ICFDB)' +
                                 ' and generate the new/updated .ado files containing the XML content/information of the object?~n~n' +
                                 'If you answer "NO", an incorrect version could be checked into the Roundtable Repository.' +
                                 ' This should ONLY be skipped if the correct version is already on the O/S (e.g.' +
                                 ' a Module Load has been done and you are just completing the task or you have just done a manual dump of the object .ado files) and NO changes have been done' +
                                 ' to the object in the Progress Dynamics repository since the module load.~n~n' +
                                 'Generate .ado XML files ? (usually choose "YES")'.
            MESSAGE
                cMesWinMessage
                VIEW-AS ALERT-BOX QUESTION
                BUTTONS YES-NO-CANCEL
                TITLE cMesWinTitle
                UPDATE lExport.

            IF NOT lExport THEN
            DO:
                ASSIGN
                    cMesWinMessage = 'Are you sure you do NOT want the use Progress Dynamics enhancement to export ICFDB repository data?.~n' +
                               'If you continue with this decision, then the incorrect content of dynamic objects could be checked into Roundtable.~n~n' +
                               'So, to be sure we will ask again...~n~n'  +
                               'Do you want to SKIP the Progress Dynamics enhancement and NOT generate the new/updated .ado file ' +
                               'containing the XML content/information of the object? (Please obtain appropriate authorisation if you answer "NO" to this question)'.

                MESSAGE
                    cMesWinMessage
                    VIEW-AS ALERT-BOX QUESTION
                    BUTTONS YES-NO-CANCEL
                    TITLE cMesWinTitle
                    UPDATE lExport.
            END.

            CASE lExport /*cMesWinButtonPressed */:
                WHEN ? /*cMesWinButtonCancel*/ /* Cancel */ THEN
                    DO:
                        ASSIGN
                            pcErrorMessage = "Object Check-In Cancelled".
                        RETURN.
                    END.

                WHEN TRUE /*"Export":U */ THEN
                RUN setActionUnderway IN gshSessionManager
                    (INPUT "SCM":U,
                    INPUT "SKIPDUMPNO":U,
                    INPUT cObjectName,
                    INPUT "":U,
                    INPUT "":U).

                WHEN FALSE /*"Skip":U*/ THEN
                RUN setActionUnderway IN gshSessionManager
                    (INPUT "SCM":U,
                    INPUT "SKIPDUMPYES":U,
                    INPUT cObjectName,
                    INPUT "":U,
                    INPUT "":U).

                OTHERWISE
                DO: /* DECIDE LATER */
                /* do nothing */
                END.
            END CASE.
        END. /* lActionUnderway = NO */
    END. /* VALID-HANDLE(gshSessionManager) */

    /* Thomas Hansen - 13/02/2010
       Make sure we do not have invalid path repository data for the object */
    RUN checkDynamicObjectPaths(
        INPUT cObjectName,
        INPUT "ppsrc/":U).

    RUN scmHookCheckInObject (
        INPUT  gcRtbCurrentWorkspace,
        INPUT  iVerTaskNum,
        INPUT  gcRtbCurrentUser,
        INPUT  cObjectName,
        INPUT hVerBuf::pmod,
        OUTPUT pcErrorMessage).

    IF pcErrorMessage <> "":U THEN
        RETURN.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

    FINALLY:
        /* Clean up */
        IF VALID-HANDLE(hData) THEN
            DELETE OBJECT hData.

        /* Clean up */
        IF VALID-HANDLE(hVerData) THEN
            DELETE OBJECT hVerData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-checkoutObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE checkoutObject Procedure
PROCEDURE checkoutObject :
    /*------------------------------------------------------------------------------
          Purpose:     After object is checked out
          Parameter :  pcContext       : STRING value of ROWID of the Brtb_object table
          / Meaning :  pcOther         : Object name
                       pcErrorMessage : ignored

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE hVerData AS HANDLE NO-UNDO.

    /* Start : Time Stamping*/
    oRtbProxyHelper:custRtbSetVerUpdNotes (
        INPUT pcContext,
        INPUT SUBSTITUTE("[Object checked out] &1 &2:~n&3", STRING(NOW, "99/99/9999 HH:MM:SS+HH:MM":U), gcRtbCurrentUser, gcVersionNotesTemplate),
        FALSE,
        INPUT "*[Object checked out]*").
    /* End: Time Stamping*/

    IF pcErrorMessage NE "":U THEN
        RETURN.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

    FINALLY:
        /* Clean up */
        IF VALID-HANDLE(hVerData) THEN
            DELETE OBJECT hVerData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-checkoutObjectBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE checkoutObjectBefore Procedure
PROCEDURE checkoutObjectBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before object is checked out
          Parameter :  pcContext       : STRING value of ROWID of the Brtb_object table
          / Meaning :  pcOther         : Object name
                       pcErrorMessage : non blank will cancel

          Notes:       There is no concept of checking out objects in the Dynamics
                       repository. But, we can use this hook to check if the object
                       exists in the ICFDB database. If it does, then we should try
                       and get it created in the ICFDB database.

                       The checks to see if objects should be registered in the ICFDB
                       database (if RTB expects a .ado file) and other checks will be
                       done in ryscmevntp.p - where this is already being done for the
                       hooks to move objects to a new module.

                       We will use the same hook as the one to move objects to a new module
                       as this does exactly the same thing.
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cObjectName         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectType         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cPmod               AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspaceID        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cCheckOutLevel      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lPriPmodSourceFound AS LOGICAL   NO-UNDO.

    ASSIGN
        cObjectName    = ENTRY(1, pcOther)
        cObjectType    = ENTRY(2, pcOther)
        cPmod          = ENTRY(3, pcOther)
        cWorkspaceID   = ENTRY(4, pcOther)
        cCheckOutLevel = ENTRY(5, pcOther).

    lPriPmodSourceFound = oRtbProxyHelper:custFindPriWorkspaceSrcPmod(gcRtbCurrentWorkspace, cPmod).

    IF NOT lPriPmodSourceFound THEN
        ASSIGN
            pcErrorMessage = "You cannot check out an object in a module that is not primary to this workspace." + CHR(10) +
                                "Object check-out cancelled".

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-compileObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE compileObject Procedure
PROCEDURE compileObject :
    /*------------------------------------------------------------------------------
      Purpose:     After object is compiled
      Parameter :  pcContext       : STRING value of ROWID of the Brtb_object table
      / Meaning :  pcOther         : Object name
                   pcErrorMessage : ignored

      Notes:

    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cObjectName  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectType  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cPmod        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspaceId AS CHARACTER NO-UNDO.

    ASSIGN
        cObjectName  = ENTRY(1, pcOther)
        cObjectType  = ENTRY(2, pcOther)
        cPmod        = ENTRY(3, pcOther)
        cWorkspaceId = ENTRY(4, pcOther).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-compileObjectBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE compileObjectBefore Procedure
PROCEDURE compileObjectBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before object is compiled
          Parameter :  pcContext       : STRING value of ROWID of the Brtb_object table
          / Meaning :  pcOther         : Object name
                       pcErrorMessage : non blank will cancel

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cObjectName  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectType  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cPmod        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspaceId AS CHARACTER NO-UNDO.

    ASSIGN
        cObjectName  = ENTRY(1, pcOther)
        cObjectType  = ENTRY(2, pcOther)
        cPmod        = ENTRY(3, pcOther)
        cWorkspaceId = ENTRY(4, pcOther).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-completeTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE completeTask Procedure
PROCEDURE completeTask :
    /*------------------------------------------------------------------------------
          Purpose:     After task completed
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : task number
                       pcErrorMessage : ignored

          Notes:       Update test status of Dynamics task to 3-COM if a DEV task or 4-TOT
                       if not a DEV task.
                       The roundtable write trigger will update the actual task status
                       and completed date.
                       The Dynamics write trigger will update the task history with the
                       new test area details.

        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cButton         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cErrorText      AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lActionUnderway AS LOGICAL   NO-UNDO.

    IF VALID-HANDLE(gshSessionManager) THEN
    DO:
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "SKIPDUMPYES":U,
            INPUT  pcOther,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "SKIPDUMPNO":U,
            INPUT  pcOther,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

        RUN getActionUnderway IN gshSessionManager  (
            INPUT  "SCM":U,
            INPUT  "TASKCOMP":U,
            INPUT  pcOther,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).
    END. /* VALID-HANDLE(gshSessionManager) */

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-completeTaskBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE completeTaskBefore Procedure
PROCEDURE completeTaskBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before task is completed
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : task number
                       pcErrorMessage : non blank will cancel

          Notes:       IMPORTANT NOTE ABOUT USING THE RTB API:
                       If the task completion is being run in batch mode using the RTB API,
                       there is no way the user can be asked if they want to export the
                       contents of the .ado files. It is therefore up to the users themselves
                       to have made sure that the .ado files are up to date before the task is
                       completed.

                       Furthermore, the batch session may not have the Dynamics managers running,
                       and we can therefore not use the API calls used by the intgeration to
                       auto dump .ado file contents.
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lExport       AS LOGICAL NO-UNDO.
    DEFINE VARIABLE lSkipExport   AS LOGICAL NO-UNDO.
    DEFINE VARIABLE lTaskComplete AS LOGICAL NO-UNDO.

    ASSIGN
        cMesWinTitle = "Task Completion (Dynamics Enhancement)":U.

    IF NOT SESSION:BATCH-MODE THEN
        IF VALID-HANDLE(gshSessionManager) THEN
        DO:
            ASSIGN
                cMesWinMessage = 'Do you wish to automatically export the objects information from the Progress Dynamics repository (ICFDB)'
                              + ' and generate the new/updated .ado files containing the XML content/information of the object?'
                              + CHR(10) + CHR(10)
                              + 'If you answer "NO", an incorrect version could be checked into the Roundtable Repository.'
                              + ' This should ONLY be skipped if the correct version is already on the O/S (e.g.'
                              + ' a Module Load has been done and you are just completing the task or you have just done a manual dump of the object .ado files) and NO changes have been done'
                              + ' to the object in the Progress Dynamics repository since the module load.'
                              + CHR(10) + CHR(10)
                              + 'Generate .ado XML files ? (usually choose "YES")'.
            MESSAGE
                cMesWinMessage
                VIEW-AS ALERT-BOX QUESTION
                BUTTONS YES-NO-CANCEL
                TITLE cMesWinTitle
                UPDATE lExport.

            IF lExport = ? /* Cancel */ THEN
            DO:
                ASSIGN
                    pcErrorMessage = "Task Completion Cancelled".
                RETURN.
            END.
            ELSE
                IF NOT lExport /*LOOKUP(cMesWinButtonPressed,"Skip All":U) > 0 */ THEN
                DO:
                    ASSIGN
                        cMesWinMessage = 'Are you sure you do NOT want the use Progress Dynamics enhancement to export ICFDB repository data?.'
                              + CHR(10)
                              + 'If you continue with this decision, then the incorrect content of dynamic objects could be checked into Roundtable.'
                              + CHR(10) + CHR(10)
                              + 'So, to be sure we will ask again...'
                              + CHR(10) + CHR(10)
                              + 'Do you want to SKIP the Progress Dynamics enhancement and NOT generate the new/updated .ado file '
                              + 'containing the XML content/information of the object? (Please obtain appropriate authorisation if you answer "NO" to this question)'.

                    MESSAGE
                        cMesWinMessage
                        VIEW-AS ALERT-BOX QUESTION
                        BUTTONS YES-NO-CANCEL
                        TITLE cMesWinTitle
                        UPDATE lSkipExport.
                END.
                ELSE
                    ASSIGN lSkipExport = FALSE.

            CASE lSkipExport /*cMesWinButtonPressed */:
                WHEN ? /*cMesWinButtonCancel*/ /* Cancel */ THEN
                    DO:
                        ASSIGN
                            pcErrorMessage = "Task Completion Cancelled".
                        RETURN.
                    END.
                WHEN FALSE /*"Export All":U */ THEN
                    DO:
                        RUN setActionUnderway IN gshSessionManager (INPUT "SCM":U,
                            INPUT "SKIPDUMPNO":U,
                            INPUT pcOther,
                            INPUT "":U,
                            INPUT "":U).
                    END.
                WHEN TRUE /*"Skip All":U */ THEN
                    DO:
                        RUN setActionUnderway IN gshSessionManager (INPUT "SCM":U,
                            INPUT "SKIPDUMPYES":U,
                            INPUT pcOther,
                            INPUT "":U,
                            INPUT "":U).
                    END.
            END CASE.

            RUN setActionUnderway IN gshSessionManager (INPUT "SCM":U,
                INPUT "TASKCOMP":U,
                INPUT pcOther,
                INPUT "":U,
                INPUT "":U).
        END. /* VALID-HANDLE(gshSessionManager) */

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-createEntityDataSet) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createEntityDataSet Procedure
PROCEDURE createEntityDataSet :
/*------------------------------------------------------------------------------
  Purpose:
  Parameters:  <none>
  Notes:     Create a new dataset for storing the GSCEM data for a site
------------------------------------------------------------------------------*/
/* 17/03/2006 appSolutions: This code is commented out for now, as it is not ready for implementation  */
/*
   DEFINE OUTPUT PARAMETER prObjectRecid   AS RECID      NO-UNDO.
   DEFINE OUTPUT PARAMETER pcError         AS CHARACTER  NO-UNDO.

   DEFINE VARIABLE iRTBSiteNumber          AS INTEGER    NO-UNDO.
   DEFINE VARIABLE cRTBSiteNumber          AS CHARACTER  NO-UNDO.
   DEFINE VARIABLE cDataSetPmodName        AS CHARACTER  NO-UNDO.
   DEFINE VARIABLE cEntityDataSetName      AS CHARACTER  NO-UNDO.

   DEFINE BUFFER Brtb_pmod FOR rtb_pmod.

   RUN scmGetSiteNumber (OUTPUT iRTBSiteNumber).
   ASSIGN cRTBSiteNumber = STRING(iRTBSiteNumber, "000":U).

   /* Check if we have a product module to create this under */
   /* For now we are using a hard-coded naming convention for this
      using the naming convention: <site number>* + _*icfdump".
      For example, for site 011, the product module should be : 011db-icfdump */

   ASSIGN
      cDataSetPmodName   = cRTBSiteNumber + "*_*icfdump":U
      cEntityDataSetName = cRTBSiteNumber + gcApplicationCode + "_GSCEM.ado":U.
   FIND FIRST Brtb_pmod WHERE Brtb_pmod.pmod = cDataSetPmodName NO-LOCK NO-ERROR.
   /* If we have a product module with the ocrrect name, then we are all set to create a new objects.  */
   IF AVAILABLE Brtb_pmod THEN
     RUN scmCreateObjectControl (INPUT cEntityDataSetName, /* pcObjectName           */
                                 INPUT "PCODE":U,          /* pcObjectType           */
                                 INPUT "DataSet":U,        /* pcSubType              */
                                 INPUT Brtb_pmod.pmod,     /* pcScmProductModule     */
                                 INPUT "DataSet":U,        /* pcGroup                */
                                 INPUT 000,                /* piLevel                */
                                 INPUT "Custom variant GCSEM DataSet for site" + cRTBSiteNumber,/* pcObjectDescription */
                                 INPUT "":U,               /* pcOptions              */
                                 INPUT giRTBCurrentTaskNum,/* piTaskNumber           */
                                 INPUT NO,                 /* plUiOn                 */
                                 INPUT "Central":U,        /* pcShareStatus          */
                                 INPUT NO,                 /* plCreatePhysicalFile  - only valid for RYCSO objects*/
                                 INPUT "":U,               /* pcPhysicalFileTemplate */
                                 OUTPUT prObjectRecid,     /* prRecid                */
                                 OUTPUT pcError).          /* pcRejection            */
   ELSE
   DO:
      ASSIGN
         pcError = "Product module " + cDataSetPmodName + " for creating a new Entity DataSet (GSCEM) not found! " + "~n":U +
                   "Please create this product module and enable it in the workspace." +  "~n":U +
                   "Then create the DataSet object manually in this product using the Dynamics DataSet export".
   END.
*/
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createObjectVariant) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createObjectVariant Procedure
PROCEDURE createObjectVariant :
    /*------------------------------------------------------------------------------
          Purpose:     After moved an object to a new product module
          Parameter :  pcContext       : STRING value of ROWID of the Brtb_object table
          / Meaning :  pcOther         : Object name
                       pcErrorMessage : ignored

       Notes:
     ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lActionUnderway AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE hObjectData     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hBuf            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerData        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cObjectName     AS CHARACTER NO-UNDO.

    ASSIGN
        cObjectName = ENTRY(1, pcOther).

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "DYN":U,
            INPUT  "ANY":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).
    IF lActionUnderway = YES THEN
        RETURN.

    hObjectData = oRtbProxyHelper:rtbGetObjectByRowidHandle(pcContext).

    hBuf = hObjectData:DEFAULT-BUFFER-HANDLE.
    hBuf:FIND-FIRST("") NO-ERROR.

    IF NOT hBuf:AVAILABLE OR
        hBuf::OBJECT <> ENTRY(1, cObjectName, ",":U) THEN
    DO:
        MESSAGE
            "The update of data failed as the Roundtable object (Brtb_object) could not be found."
            VIEW-AS ALERT-BOX WARNING BUTTONS OK.
        ASSIGN
            pcErrorMessage = "error":U.
        RETURN.
    END.
    ELSE
        /*   We only want to handle events for PCODE objects, only if the    */
        /*   object is a PCODE object do we want to call the Dynamics hook  */
        IF hBuf::obj-type = "PCODE":U THEN
            RUN scmHookMoveModule (INPUT  gcRtbCurrentWorkspace,
                INPUT  giRtbCurrentTaskNum,
                INPUT  gcRtbCurrentUser,
                INPUT  hBuf::object,
                INPUT  hBuf::pmod,
                INPUT  hBuf::VERSION,
                OUTPUT pcErrorMessage).

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "MOV":U,
            INPUT  cObjectName,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

    /* The following code will clean up the actionUnderway table and also
       re-enable the replication triggers - which may have been
       disabled in scmHookMoveModule in rtb/prc/ryscmevntp.p
    */
    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "ASS":U,
            INPUT  cObjectName,
            INPUT  "RYCSO":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

    /* Start : appSolutions Customization - Time Stamping*/
    oRtbProxyHelper:custRtbSetVerUpdNotes (
        INPUT pcContext,
        INPUT SUBSTITUTE("[Custom variant created] &1 &2:~n&3", STRING(NOW, "99/99/9999 HH:MM:SS+HH:MM":U), gcRtbCurrentUser, gcVersionNotesTemplate),
        FALSE,
        INPUT "*[Custom variant created]*").
    /* End: appSolutions Customization - Time Stamping*/

    IF pcErrorMessage <> "":U THEN
        RETURN.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hObjectData) THEN
            DELETE OBJECT hObjectData.

        IF VALID-HANDLE(hVerData) THEN
            DELETE OBJECT hVerData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createObjectVariantBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createObjectVariantBefore Procedure
PROCEDURE createObjectVariantBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before object is moved to a new module
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Object name
                       pcErrorMessage : non blank will cancel

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lActionUnderway AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cObjectName     AS CHARACTER NO-UNDO.

    ASSIGN
        cObjectName = ENTRY(1, pcOther).

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "DYN":U,
            INPUT  "ANY":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).
    IF lActionUnderway = YES THEN
        RETURN.

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN setActionUnderway IN gshSessionManager (
            INPUT "SCM":U,
            INPUT "MOV":U,
            INPUT cObjectName,
            INPUT "":U,
            INPUT "":U).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createRelease) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createRelease Procedure
PROCEDURE createRelease :
    /*------------------------------------------------------------------------------
          Purpose:     After release is created
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Workspace id, release number
                       pcErrorMessage : ignored

          Notes:       Any errors will be ignored and will not cause the creation of the
                       release to fail.

        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createReleaseBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createReleaseBefore Procedure
PROCEDURE createReleaseBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before release is created
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Workspace id
                       pcErrorMessage : non blank will cancel

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createSite) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createSite Procedure
PROCEDURE createSite :
    /*------------------------------------------------------------------------------
          Purpose:     After deployment created
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Workspace, License Type, Site Code
                       pcErrorMessage : logical - false will cancel site creation

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createSiteBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createSiteBefore Procedure
PROCEDURE createSiteBefore :
    /*------------------------------------------------------------------------------
          Purpose:     After deployment created
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Workspace, License Type, Site Code
                       pcErrorMessage : logical - false will cancel site creation

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createTask Procedure
PROCEDURE createTask :
    /*------------------------------------------------------------------------------
          Purpose:     After task created - but no details entered yet
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : ""
                       pcErrorMessage : ignored

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createTaskBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createTaskBefore Procedure
PROCEDURE createTaskBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before task is created
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Workspace id
                       pcErrorMessage : non blank will cancel
          Notes:       Tried to put a warning in here, but this event fires even if we
                       are creating a task from Dynamics.

        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-deleteObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE deleteObject Procedure
PROCEDURE deleteObject :
    /*------------------------------------------------------------------------------
          Purpose:     After object is deleted
          Parameter :  Pcontext = WIP version of the deleted object
                       Pother   = Object Name
                       pcErrorMessage : ignored

      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lActionUnderway   AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lImportUnderway   AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lSuppressMessages AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cReturnCharacter  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectName       AS CHARACTER NO-UNDO.

    IF gcAssignObjectName = "":U THEN 
        ASSIGN 
            cObjectName = ENTRY(1, pcOther).
    ELSE
        ASSIGN 
            cObjectName = gcAssignObjectName.
             
    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "DYN":U,
            INPUT  "ANY":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lActionUnderway).
    IF  lActionUnderway = YES THEN
        RETURN.

    /* First check if we are in the process of importing.
       If we are not importing, then we do not want to log the event, as
       this is not all that useful. The collection of assign changes that
       are made during the import process are much more useful.
    */
    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "IMPORT":U,
            INPUT  gcRtbCurrentWorkspace,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  NO,
            OUTPUT lImportUnderway).

    IF lImportUnderWay THEN
    DO:
        PUBLISH "logEvent" (INPUT pcEvent,
            INPUT pcEvent + " - ":U + cObjectName,
            INPUT "ERROR":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT gcRtbCurrentUser,
            INPUT "LOG":U,
            INPUT "dynrtb_import.log",
            INPUT "":U) .

        IF pcErrorMessage <> "":U THEN
            PUBLISH "logEvent" (INPUT pcEvent,
                INPUT "ERROR / ":U + pcEvent + " (":U + cObjectName + ") : ":U + pcErrorMessage,
                INPUT "ERROR":U,
                INPUT gcRtbCurrentWorkspace,
                INPUT gcRtbCurrentUser,
                INPUT "LOG,STATUS":U,
                INPUT "dynrtb_import.log",
                INPUT "":U) .

        /* If we are suppressing error messages then reset the error message -
           as we do not want this displaying in the process-event procedure
           afterwards
        */
        cReturnCharacter =  DYNAMIC-FUNCTION("getPropertyList":U IN gshSessionManager,
            INPUT "SuppressMessages":U,
            INPUT YES).

        IF cReturnCharacter = "YES" THEN
            ASSIGN lSuppressMessages = TRUE.
        ELSE
            ASSIGN lSuppressMessages = FALSE.

        IF lSuppressMessages THEN
            ASSIGN pcErrorMessage = "":U.
    END.   /* IF lImportUnderWay ...*/

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "DEL":U,
            INPUT  gcAssignObjectName,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "SKIPDEL":U,
            INPUT  gcAssignObjectName,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lActionUnderway).

    ASSIGN
        gcAssignObjectName = "":U
        pcErrorMessage     = "":U
    NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-deleteObjectBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE deleteObjectBefore Procedure
PROCEDURE deleteObjectBefore :
    /*------------------------------------------------------------------------------
      Purpose:     Before object is deleted
      Parameter :  Pcontext = rtb_object ROWID string value
                   Pother   = Object Name, Object Type, Product Module, Workspace ID

      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lChoice         AS LOGICAL NO-UNDO.
    DEFINE VARIABLE lActionUnderway AS LOGICAL NO-UNDO.
    DEFINE VARIABLE hObjectData     AS HANDLE  NO-UNDO.
    DEFINE VARIABLE hObjBuf         AS HANDLE  NO-UNDO.
    DEFINE VARIABLE hVerData        AS HANDLE  NO-UNDO.
    DEFINE VARIABLE hVerBuf         AS HANDLE  NO-UNDO.

    ASSIGN
        gcAssignObjectName = IF NUM-ENTRIES(pcOther) > 1 THEN ENTRY(1, pcOther) ELSE pcOther.

    /*   We only want to handle delete events for PCODE objects. If the  */
    /*   object is not a PCODE object, then cancel the extension to this */
    /*   event by returning.                                             */

    hObjectData = oRtbProxyHelper:rtbGetObjectByRowidHandle(pcContext).

    hObjBuf = hObjectData:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    IF hObjBuf:AVAILABLE THEN
    DO:
        /* Get object version details */
        hVerData = oRtbProxyHelper:rtbgetVersionHandle(
            INPUT  hObjBuf::obj-type,
            INPUT  hObjBuf::object,
            INPUT  hObjBuf::pmod,
            INPUT  hObjBuf::VERSION).

        hVerBuf = hVerData:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF hVerBuf:AVAILABLE THEN
        DO:
            /* If the object being deleted is not a PCODE object, or it is a dataset, then   */
            /* we don't want to be deleteing anything in Dynamics.                           */
            IF hVerBuf::obj-type NE "PCODE":U THEN
                RETURN.
            ELSE
                /* If the object is not a Dynamics object, then we do no twant to replicate the delete event either */
                IF LOOKUP(hVerBuf::sub-type, gcNonDynamicObjectTypes) > 0 THEN
                    RETURN.

            IF VALID-HANDLE(gshSessionManager) THEN
                RUN getActionUnderway IN gshSessionManager (
                    INPUT  "DYN":U,
                    INPUT  "ANY":U,
                    INPUT  "":U,
                    INPUT  "":U,
                    INPUT  "":U,
                    INPUT  NO,
                    OUTPUT lActionUnderway).
            IF lActionUnderway = YES THEN
                RETURN.

            IF VALID-HANDLE(gshSessionManager) THEN
                RUN setActionUnderway IN gshSessionManager (
                    INPUT "SCM":U,
                    INPUT "DEL":U,
                    INPUT gcAssignObjectName,
                    INPUT "":U,
                    INPUT "":U).
            ASSIGN
                lChoice = YES.

            MESSAGE
                "Progress Dynamics Enhancement (usually say YES):"     SKIP(1)
                "Do you wish to DELETE the objects information from the Progress Dynamics Repository (ICFDB)."  SKIP(1)
                "If you answer NO, an data inconsistency could occur between the two Repositories."     SKIP(1)
                "This should ONLY be skipped if you reverting to a previous version, i.e."     SKIP
                "By doing a DELETE and reverting back to a previous version"     SKIP(1)
                "Delete the Object from the Progress Dynamics Repository ?"     SKIP(1)
                VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO
                UPDATE lChoice.

            IF lChoice = NO THEN
            DO:
                MESSAGE
                    "Are you sure you want to SKIP the Progress Dynamics enhancement and NOT delete the object from the Progress Dynamics Repository."       SKIP
                    "If you continue with this decision, then data inconsistancies could occur between the two Repositories."   SKIP(1)
                    VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO
                    UPDATE lChoice.

                IF lChoice = YES THEN
                DO:
                    IF VALID-HANDLE(gshSessionManager) THEN
                        RUN setActionUnderway IN gshSessionManager (
                            INPUT "SCM":U,
                            INPUT "SKIPDEL":U,
                            INPUT gcAssignObjectName,
                            INPUT "":U,
                            INPUT "":U).
                END.
            END.

            RUN scmHookDeleteObject (
                INPUT  gcRtbCurrentWorkspace,
                INPUT  giRtbCurrentTaskNum,
                INPUT  gcRtbCurrentUser,
                INPUT  gcAssignObjectName,
                INPUT  hVerBuf::pmod,
                OUTPUT pcErrorMessage).

            IF pcErrorMessage = "":U THEN
            DO:
                IF glShowNotifyBallonTips THEN  
                    PUBLISH "showNotifyBallonTip" ("":U, SUBSTITUTE("Object '&1' deleted from Dynamics", cObjectName), 50).
            END.
            ELSE 
                RETURN.
        END.
        ELSE
        DO:
            ASSIGN
                pcErrorMessage = SUBSTITUTE("Cannot find the version record for object '&1' in product module '&1'. Object deletion cannot be completed!", hObjBuf::object, hObjBuf::pmod).
            RETURN.
        END.
    END.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

    CATCH err AS Progress.Lang.Error :
        /***DIAG***/
        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
            err:GetMessage(1)
            VIEW-AS ALERT-BOX INFO BUTTONS OK.
    END CATCH.

    FINALLY:
        /* Clean up */
        IF VALID-HANDLE(hObjectData) THEN
            DELETE OBJECT hObjectData.

        IF VALID-HANDLE(hVerData) THEN
            DELETE OBJECT hVerData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-evRtbCustgetDebug) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustgetDebug Version
PROCEDURE evRtbCustgetDebug:
    /*------------------------------------------------------------------------------
     Purpose:
     Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER plDebug AS LOGICAL NO-UNDO.

    ASSIGN
        plDebug = glDebug.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF

&IF DEFINED(EXCLUDE-evRtbCustGetShowNotifyIcon) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetShowNotifyBallonTips Version
PROCEDURE evRtbCustGetShowNotifyBallonTips:
    /*------------------------------------------------------------------------------
     Purpose:
     Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER plShowNotifyBallonTips AS LOGICAL NO-UNDO.

    ASSIGN
        plShowNotifyBallonTips = glShowNotifyBallonTips.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF


&IF DEFINED(EXCLUDE-evRtbCustGetSID) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetSID Procedure
PROCEDURE evRtbCustGetSID :
    /*------------------------------------------------------------------------------
            Purpose:
            Parameters: <none>
            Notes:
        ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER piRtbSid AS INTEGER     NO-UNDO.

    ASSIGN
        piRTBSID = giRtbSid.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-evRtbCustGetWorkspacePath) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetWorkspacePath Version
PROCEDURE evRtbCustGetWorkspacePath:
    /*------------------------------------------------------------------------------
     Purpose:
     Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER pcRtbWorkspacePath AS CHARACTER NO-UNDO.

    ASSIGN
        pcRtbWorkspacePath = gcRtbCurrentWorkspacePath.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF

&IF DEFINED(EXCLUDE-evRtbCustGetWorkspaceRoot) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetWorkspaceRoot Procedure
PROCEDURE evRtbCustGetWorkspaceRoot :
    /*------------------------------------------------------------------------------
            Purpose:
            Parameters: <none>
            Notes:
        ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER pcWorkspaceRoot AS CHARACTER   NO-UNDO.

    ASSIGN
        pcWorkspaceRoot = gcRtbCurrentWorkspaceRoot.

    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-evRtbCustSetDebug) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustSetDebug Version
PROCEDURE evRtbCustSetDebug:
    /*------------------------------------------------------------------------------
     Purpose:
     Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  plDebugOn AS LOGICAL NO-UNDO.

    ASSIGN
        glDebug = plDebugOn.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF

&IF DEFINED(EXCLUDE-evRtbCustSetRTBASHandle) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustSetRTBASHandle Version
PROCEDURE evRtbCustSetRTBASHandle:
    /*------------------------------------------------------------------------------
     Purpose:
     Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER phRtbAppServerhandle AS HANDLE NO-UNDO.

    ASSIGN
        ghRtbAs = phRtbAppServerhandle.

    IF VALID-OBJECT(oRtbProxyHelper) AND
        oRtbProxyHelper:AppServerHandle NE ghRtbAs THEN
        oRtbProxyHelper:AppServerHandle = ghRtbAs.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF

&IF DEFINED(EXCLUDE-evRtbCustSetWorkspacePath) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustSetWorkspacePath Version
PROCEDURE evRtbCustSetWorkspacePath:
    /*------------------------------------------------------------------------------
     Purpose:
     Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcRtbWorkspacePath AS CHARACTER NO-UNDO.

    ASSIGN
        gcRtbCurrentWorkspacePath = pcRtbWorkspacePath.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF


&IF DEFINED(EXCLUDE-evRtbCustSetWorkspaceRoot) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustSetWorkspaceRoot Version
PROCEDURE evRtbCustSetWorkspaceRoot:
    /*------------------------------------------------------------------------------
     Purpose:
     Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcRtbWorkspaceRoot AS CHARACTER NO-UNDO.

    ASSIGN
        gcRtbCurrentWorkspaceRoot = pcRtbWorkspaceRoot.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF


&IF DEFINED(EXCLUDE-evRtbGetCurrentTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbGetCurrentTask Procedure
PROCEDURE evRtbGetCurrentTask :
    /*------------------------------------------------------------------------------
          Purpose:     Event procedure  to return currently selected task
          Parameters:  OUTPUT Ptask-num AS INTEGER
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER piTaskNum AS INTEGER    NO-UNDO.

    ASSIGN
        piTaskNum = giRtbCurrentTaskNum.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-ICFCFM_SessionShutdown) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ICFCFM_SessionShutdown Procedure
PROCEDURE ICFCFM_SessionShutdown :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters:  <none>
          Notes:
        ------------------------------------------------------------------------------*/
    /* Shut down this procedxure - as the framework is being shut down */
    RUN killPlip.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-ICFSTART_BeforeInitialize) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ICFSTART_BeforeInitialize Procedure
PROCEDURE ICFSTART_BeforeInitialize :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters:  <none>
          Notes:
        ------------------------------------------------------------------------------*/

    DEFINE VARIABLE cSessionTypeRTB       AS CHARACTER NO-UNDO.

    DEFINE VARIABLE iSessionParamLoop     AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cSessionParameters    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionParamEntry    AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cSessionDefaultConfig AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionDefaultType   AS CHARACTER NO-UNDO.

    /* Make sure that we have the current workspace selected -
       this is not the case here when coming from OEA */
    /* Get the current workspace  */
    PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT gcRtbCurrentWorkspace).

    ASSIGN
        cSessionDefaultConfig = "icfconfig.xml":U
        cSessionDefaultType   = "Default":U
        cSessionParameters    = SESSION:ICFPARAM.

    blockSessionParam:
    DO iSessionParamLoop = 1 TO NUM-ENTRIES(cSessionParameters):

        ASSIGN
            cSessionParamEntry = ENTRY(iSessionParamLoop, cSessionParameters).

        /* If there are no = or more than one =, this is an invalid parameter, so ignore it. */
        IF NUM-ENTRIES(cSessionParamEntry,"=":U) <> 2 THEN
            NEXT blockSessionParam.

        IF ENTRY(1,cSessionParamEntry,"=":U) = "ICFCONFIG":U THEN
            ASSIGN cSessionDefaultConfig = ENTRY(2,cSessionParamEntry,"=":U).

        IF ENTRY(1,cSessionParamEntry,"=":U) = "ICFSESSTYPE":U THEN
            ASSIGN cSessionDefaultType = ENTRY(2,cSessionParamEntry,"=":U).
    END.

    IF gcRtbCurrentWorkspace NE "":U THEN
        ASSIGN cSessionDefaultType = "rtb_" + REPLACE(gcRtbCurrentWorkspace,"-","").

    IF cSessionDefaultConfig NE "":U THEN
        ASSIGN cSessionTypeRTB = "ICFCONFIG=" + cSessionDefaultConfig.

    IF cSessionDefaultType NE "":U THEN
        ASSIGN
            cSessionTypeRTB = cSessionTypeRTB + (IF cSessionTypeRTB <> "" THEN "," ELSE "")
                      + "ICFSESSTYPE=" + cSessionDefaultType.

    IF cSessionTypeRTB = "":U THEN
        ASSIGN cSessionTypeRTB = SESSION:ICFPARAM.

    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "ICFPARAM":U, cSessionTypeRTB ).
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "quit_on_end":U, "NO" ).

    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "shut_on_end":U, "NO" ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-killPlip) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE killPlip Procedure
PROCEDURE killPlip :
    /*------------------------------------------------------------------------------
          Purpose:     entry point to instantly kill the plip if it should get lost in memory
          Parameters:  <none>
          Notes:
        ------------------------------------------------------------------------------*/

    {ry/app/ryplipkill.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-loadPartner) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE loadPartner Procedure
PROCEDURE loadPartner :
    /*------------------------------------------------------------------------------
          Purpose:     After partner load
          Parameter :  pcContext       : String value of ROWID of rtb.rtb_wspace loaded
          / Meaning :  pcOther         : Workspace Path, /* entry 1 is the root path */
                       pcErrorMessage : ignored

          Notes:

        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.


    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-loadPartnerBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE loadPartnerBefore Procedure
PROCEDURE loadPartnerBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before partner load
          Parameter :  pcContext       : Potential Workspace ID,   /* no records are created yet */
          / Meaning :  pcOther         : Workspace Path,  /* entry 1 is the root path */
                       pcErrorMessage : Cancel load if FALSE

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-makeDeployment) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE makeDeployment Procedure
PROCEDURE makeDeployment :
    /*------------------------------------------------------------------------------
      Purpose:     After deployment created
      Parameter :  pcContext       : STRING value of ROWID of the rtb_site table
      / Meaning :  pcOther         : STRING value of ROWID of the rtb_deploy table
                   pcErrorMessage : ignored

      Notes:

    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lDeployQuestion     AS LOGICAL   INITIAL YES NO-UNDO.
    DEFINE VARIABLE cError              AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lExtendedDeployment AS LOGICAL   INITIAL YES NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-makeDeploymentBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE makeDeploymentBefore Procedure
PROCEDURE makeDeploymentBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before deployment created
          Parameter :  pcContext       : STRING value of ROWID of the rtb_site table
          / Meaning :  pcOther         : STRING value of ROWID of the rtb_deploy table
                       pcErrorMessage : non blank will cancel deployment creation

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-modifyTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE modifyTask Procedure
PROCEDURE modifyTask :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameter :
                      Pcontext = rtb_task ROWID string value
                      Pother   = Task Number
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-modifyTaskBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE modifyTaskBefore Procedure
PROCEDURE modifyTaskBefore :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameter :
                      Pcontext = RowObjUpd buffer handle string value
                      Pother   = Task Number
                      Pok      = False will cancel

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-moveToWeb) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE moveToWeb Procedure
PROCEDURE moveToWeb :
    /*------------------------------------------------------------------------------
          Purpose:     After moved to WEB
          Parameter :  pcContext       : STRING value of ROWID of rtb.Brtb_object
          / Meaning :  pcOther         : INPUT Object, Obj-Type, Pmod, WS Module
                       pcErrorMessage : ignored

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-moveToWebBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE moveToWebBefore Procedure
PROCEDURE moveToWebBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before move to WEB
          Parameter :  pcContext       : STRING value of ROWID of rtb.Brtb_object
          / Meaning :  pcOther         : INPUT Object, Obj-Type, Pmod, WS Module
                       pcErrorMessage : non blank will cancel

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-newTaskRow) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE newTaskRow Procedure
PROCEDURE newTaskRow :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameter :
                      Pcontext = RowObject buffer handle string value
                      Pother   = Workspace ID
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-plipSetup) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipSetup Procedure
PROCEDURE plipSetup :
    /*------------------------------------------------------------------------------
          Purpose:    Run by main-block of PLIP at startup of PLIP
          Parameters: <none>
          Notes:
        ------------------------------------------------------------------------------*/
    {ry/app/ryplipsetu.i}

    DEFINE VARIABLE cProcName   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hProcHandle AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cRtbVerFile AS CHARACTER NO-UNDO.

    /* Subscribe to the shutdown event - so that we can shut down this procedxure
       when the framework shuts down  */
    SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "ICFCFM_SessionShutdown":U ANYWHERE.

    /* Get the current workspace  */
    PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT gcRtbCurrentWorkspace).

    /* Get the current user */
    PUBLISH "evRtbGetCurrentUser":U (OUTPUT gcRtbCurrentUser).

    /* Get the current user */
    PUBLISH "evRtbCustGetCurrentPassword":U (OUTPUT gcRtbCurrentUserPassword).

    ASSIGN
        cProcName   = "rtb/prc/ryscmevntp.p":U
        hProcHandle = SESSION:FIRST-PROCEDURE.

    DO WHILE VALID-HANDLE(hProcHandle) AND
        hProcHandle:FILE-NAME <> cProcName:
        hProcHandle = hProcHandle:NEXT-SIBLING.
    END.

    IF NOT VALID-HANDLE(hProcHandle) THEN
        RUN VALUE(cProcName) PERSISTENT SET hProcHandle.

    THIS-PROCEDURE:ADD-SUPER-PROCEDURE(hProcHandle, SEARCH-TARGET).

    /* Check the version of RTB that we are using. This is needed due to difference in some
      of the routines to start SDOs and super procedures.
    */
    ASSIGN
        cRtbVerFile = SEARCH("rtbver").
    IF cRtbVerFile NE ? THEN
    DO:
        /* read and parse the rtbver file. This is the actual file for the RTB version we are
           using and not the one we use at compilation time - as they may be different */
        INPUT FROM VALUE(cRtbVerFile).
        IMPORT UNFORMATTED gcRtbVersion.
        INPUT CLOSE.

        IF gcRtbVersion NE "":U THEN
            ASSIGN
                gcRtbVersion = TRIM(REPLACE(gcRTBVersion, "Roundtable TSMS release ":U, "":U)).
    END.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-plipShutdown) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipShutdown Procedure
PROCEDURE plipShutdown :
    /*------------------------------------------------------------------------------
          Purpose:     This procedure will be run just before the calling program
                       terminates
          Parameters:  <none>
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cProcName     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hValidHandles AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hProcHandle   AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cError        AS CHARACTER NO-UNDO.

    IF VALID-HANDLE(ghRtbAs) AND
        ghRtbAs NE SESSION:HANDLE THEN
    DO ON ERROR UNDO, THROW:
        /* Log out of the appServer session - if necessary */
        oRtbProxyHelper:rtbSessionLogout (giRTBSid) NO-ERROR.

        ghRtbAs:DISCONNECT().
        DELETE OBJECT ghRtbAs.

        CATCH err AS Progress.Lang.Error :
            UNDO, THROW err.
        END CATCH.
    END.

    ASSIGN
        cProcName     = "ryscmevntp.p":U
        hValidHandles = SESSION:FIRST-PROCEDURE.

    DO WHILE VALID-HANDLE(hValidHandles) AND
        NOT (VALID-HANDLE(hProcHandle)):

        IF hValidHandles:PRIVATE-DATA = cProcName THEN
            ASSIGN hProcHandle = hValidHandles.

        ASSIGN
            hValidHandles = hValidHandles:NEXT-SIBLING.
    END.

    IF VALID-HANDLE(hProcHandle) THEN
        RUN killPlip IN hProcHandle.

    IF VALID-OBJECT(oRtbProxyHelper) THEN
        DELETE OBJECT oRtbProxyHelper.

    {ry/app/ryplipshut.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-processEvent) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE processEvent Procedure
PROCEDURE processEvent :
    /*------------------------------------------------------------------------------
      Purpose:      Event control procedure hook
      Parameters:   pcEvent = name of event
                    pcContext = event dependant
                    pcOther = event dependant
                    pcErrorMessage = An error message to display in the event of failure

      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE hValidHandles    AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cSummaryMessages AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cFullMessages    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cButtonList      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cMessageTitle    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lUpdateErrorLog  AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lSuppressDisplay AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cButton          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cBallonTipText   AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.

    /* Get the variables that we need for event handling */
    /* Get the current workspace  */
    PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT gcRtbCurrentWorkspace).

    /* Get the current task */
    PUBLISH "evRtbGetCurrentTask":U (OUTPUT giRtbCurrentTaskNum).

    /* Get the current user */
    PUBLISH "evRtbGetCurrentUser":U (OUTPUT gcRtbCurrentUser).

    IF glDebug AND
        glShowNotifyBallonTips THEN
    DO:
        ASSIGN
            cBallonTipText = SUBSTITUTE("Event   : &1~n", pcEvent) +
                             SUBSTITUTE("Other   : &1", pcOther).
        PUBLISH "showNotifyBallonTip" ("":U, cBallonTipText, 50).
    END.

    /*
    IF pcEvent = "assignObjectBefore":U OR
       pcEvent = "assignObject":U OR
       pcEvent = "createObjectVariantBEFORE":U OR
       pcEvent = "createObjectVariant":U OR
       pcEvent = "addObjectBefore":U    OR
       pcEvent = "addObject":U OR
       pcEvent = "deleteObjectBefore":U OR
       pcEvent = "deleteObject":U  THEN
    DO:

    DEFINE VARIABLE lv_choice AS LOGICAL NO-UNDO.
    MESSAGE
        SKIP "Event: "   pcEvent
        SKIP "Context: " pcContext
        SKIP "Other: "   pcOther
        VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO UPDATE lv_choice.
    IF lv_choice = NO
    THEN DO:
      ASSIGN
        pcErrorMessage  = "Error".
      RETURN.
    END.
 /*                        */
 /*     {af/sup/afdebug.i} */
  END.
  */

    IF NOT CONNECTED("ICFDB":U) THEN
        RETURN.

    /* Start the oRtbProxyHelper object - if it is available */
    IF NOT VALID-OBJECT(oRtbProxyHelper) THEN
        oRtbProxyHelper = scm.custom.rtb.Env:RTBProxyHelper.

    IF NOT VALID-OBJECT(oTempTableHelper) THEN
        oTempTableHelper = scm.custom.rtb.Env:TempTableHelper.

    /* Get the appServer connection  */
    IF NOT VALID-HANDLE(ghRtbAs) THEN
        PUBLISH "evRtbCustSetRTBASConnection" (INPUT "":U).

    IF VALID-HANDLE(ghRtbAs) THEN 
    DO:
        IF oRtbProxyHelper:AppServerhandle NE ghRtbAs THEN 
            oRtbProxyHelper:AppServerhandle = ghRtbAs.
    END.
    CASE pcEvent:
        /* OEIDE RTB only events - are all being handled in rtbpreevent.p - and should not be handled here */

        /* RTB GUI & Common Events */
        WHEN "assignObject":U                       THEN RUN assignObject                  (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "assignObjectBefore":U                 THEN RUN assignObjectBefore            (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "beforeChangeWorkspace":U              THEN RUN beforeChangeWorkspace         (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "changeWorkspace":U                    THEN RUN changeWorkspace               (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "createObjectVariant":U                THEN RUN createObjectVariant           (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "createObjectVariantBefore":U          THEN RUN createObjectVariantBefore     (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "makeDeployment":U                     THEN RUN makeDeployment                (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "makeDeploymentBefore":U               THEN RUN makeDeploymentBefore          (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "createSite":U                         THEN RUN createSite                    (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "createSiteBefore":U                   THEN RUN createSiteBefore              (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "processImport":U                      THEN RUN processImport                 (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "processImportBefore":U                THEN RUN processImportBefore           (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "moveToWeb":U                          THEN RUN moveToWeb                     (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "moveToWebBefore":U                    THEN RUN moveToWebBefore               (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "addObject":U                          THEN RUN addObject                     (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "addObjectBefore":U                    THEN RUN addObjectBefore               (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "addObjectUI":U                        THEN RUN addObjectUI                     (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "changeObjectShareStatusBefore":U      THEN RUN changeObjectShareStatusBefore (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "changeObjectShareStatus":U            THEN RUN changeObjectShareStatus       (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "checkinObject":U                      THEN RUN checkinObject                 (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "checkinObjectBefore":U                THEN RUN checkInObjectBefore           (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "checkoutObject":U                     THEN RUN checkoutObject                (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "checkoutObjectBefore":U               THEN RUN checkoutObjectBefore          (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "compileObject":U                      THEN RUN compileObject                 (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "compileObjectBefore":U                THEN RUN compileObjectBefore           (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "deleteObject":U                       THEN RUN deleteObject                  (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "deleteObjectBefore":U                 THEN RUN deleteObjectBefore            (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "loadPartner":U                        THEN RUN loadPartner                   (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "loadPartnerBefore":U                  THEN RUN loadPartnerBefore             (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "changePropath":U                      THEN RUN changePropath                 (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "changePropathBefore":U                THEN RUN changePropathBefore           (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "createRelease":U                      THEN RUN createRelease                 (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "createReleaseBefore":U                THEN RUN createReleaseBefore           (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "roundtableStartup":U                  THEN RUN roundtableStartup             (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "roundtableShutdown":U                 THEN RUN roundtableShutdown            (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "updateSchema":U                       THEN RUN updateSchema                  (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "updateSchemaBefore":U                 THEN RUN updateSchemaBefore            (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "sessionShutdown":U                    THEN RUN session-shutdown              (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "changeTask":U                         THEN RUN changeTask                    (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "completeTask":U                       THEN RUN completeTask                  (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "completeTaskBefore":U                 THEN RUN completeTaskBefore            (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "createTask":U                         THEN RUN createTask                    (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "createTaskBefore":U                   THEN RUN createTaskBefore              (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "buildImportListBefore:U"              THEN RUN buildImportListBefore         (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "buildImportList:U"                    THEN RUN buildImportList               (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "buildSchemaList:U"                    THEN RUN buildSchemaList               (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "modifyTaskBefore:U"                   THEN RUN modifyTaskBefore              (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "modifyTask:U"                         THEN RUN modifyTask                    (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
        WHEN "newTaskRow:U"                         THEN RUN newTaskRow                    (INPUT pcEvent, INPUT pcContext, INPUT pcOther, OUTPUT pcErrorMessage).
    END CASE.

    /* Try and display a nice formatted error if we can */
    IF pcErrorMessage NE "":U THEN
    DO:
        IF VALID-HANDLE(gshSessionManager) THEN
        DO:
            RUN showMessages IN gshSessionManager
                (INPUT pcErrorMessage,
                INPUT "ERR":U,
                INPUT "OK":U,
                INPUT "OK":U,
                INPUT "OK":U,
                INPUT "RTB Error",
                INPUT YES,
                INPUT ?,
                OUTPUT cButton).

            ASSIGN
                pcErrorMessage = "Failed".
        END.
        ELSE
        DO:
            RUN afmessagep IN gshSessionManager
                (INPUT  pcErrorMessage,
                INPUT  "OK":U,
                INPUT  "RTB Error":U,
                OUTPUT cSummaryMessages,
                OUTPUT cFullMessages,
                OUTPUT cButtonList,
                OUTPUT cMessageTitle,
                OUTPUT lUpdateErrorLog,
                OUTPUT lSuppressDisplay).

            ASSIGN
                pcErrorMessage = cFullMessages.
        END.
    END.

    RETURN.
   
    CATCH err AS Progress.Lang.Error :
        ASSIGN 
            pcErrorMessage = err:GetMessage(1).  
    END CATCH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-processImport) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE processImport Procedure
PROCEDURE processImport :
    /*------------------------------------------------------------------------------
          Purpose:     After processImport
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Workspace id
                       pcErrorMessage : ignored

          Notes:       The contents of this hook have been moved to the before-assign hook so
                       every movement of an object is captured rather than just via an import.

                       This procedure will be run automatically from Roundtable when an import is
                       completed.

        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cFileName       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cFileList       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lImportUnderway AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cMessage        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cButton         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cAnswer         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cTitle          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hRTBSdo         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE iRTBSid         AS INTEGER   NO-UNDO.
    DEFINE VARIABLE hStatusWin      AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cCompileError   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cImportObject   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cImportPmod     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hCompiler       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE lAnswer         AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE hData           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hBuf            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hQry            AS HANDLE    NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.

    ASSIGN
        cMessage = "Print a report of the import table as an audit detailing which objects were included in the import."
        cTitle   = "Roundtable Import Control (Dynamics Enhancement)":U.

    IF VALID-HANDLE(gshSessionManager) THEN
        RUN showMessages IN gshSessionManager (INPUT  cMessage,  /* message to display */
            INPUT  "INF":U,   /* error type */
            INPUT  "&OK":U,   /* button list */
            INPUT  "&OK":U,   /* default button */
            INPUT  "":U,      /* cancel button */
            INPUT  cTitle,    /* error window title */
            INPUT  NO,        /* display if empty */
            INPUT  ?,         /* container handle */
            OUTPUT cButton).  /* button pressed */
    ELSE
        /* Display the message with a normal message dialog  */
        MESSAGE
            cMessage
            VIEW-AS ALERT-BOX INFORMATION BUTTONS OK
            TITLE cTitle.

    ASSIGN
        cFileList = "":U.

    hData = oRtbProxyHelper:rtbGetWorkspaceImportsHandle(gcRtbCurrentWorkspace).

    hBuf = hData:DEFAULT-BUFFER-HANDLE.
    CREATE QUERY hQry.
    hQry:SET-BUFFERS(hBuf).
    hQry:QUERY-PREPARE("FOR EACH " + hData:NAME).
    hQry:QUERY-OPEN.
    hQry:GET-FIRST.
    DO WHILE NOT hQry:QUERY-OFF-END:
        ASSIGN
            cImportObject = hBuf::object
            cImportPmod   = hBuf::pmod.

        IF INDEX(cImportObject,".df":U) = 0 THEN
        DO:
            hQry:GET-NEXT.
            NEXT.
        END.

        cError = DYNAMIC-FUNCTION('fnRtbGetObjectPartnames':U,
            INPUT "",                /* no root path to get relative path names */
            INPUT cImportPmod,   /*product Module */
            INPUT "DataDef":U,       /*Code Subtype */
            INPUT cImportObject, /* Name of object */
            INPUT "PCODE":U,         /* Comma separated list of object parts - one entry in this case*/
            OUTPUT cFileName).

        /* As cFilename may contain multiple file parts, only keep the first part */
        cFilename = ENTRY(1, cFileName).
        ASSIGN
            cFileList = cFileList
                         + (IF cFileList <> "":U THEN ",":U ELSE "":U)
                         + cFileName.
        hQry:GET-NEXT.
    END.

    IF cFileList <> "":U THEN
    DO:
        PUBLISH "logEvent" (INPUT pcEvent,
            INPUT "Import contained .df files. Remember to update databases with changes." + "~n",
            INPUT "":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT gcRtbCurrentUser,
            INPUT "LOG":U,
            INPUT "dynrtb_import.log",
            INPUT "":U) .

        ASSIGN
            cMessage = "The import table contained delta files that may need to be applied to the " +
                     "databases in this workspace manually. Review the IMPORT list to see what deltas " +
                     "were included. Ensure any databases you are going to apply deltas for are connected " +
                     "and that no procedures are running that reference them." + "~n" + "~n" +
                     "Also be sure that the deltas in the list are not for common databases or have " +
                     "not already been applied manually." + "~n" + "~n" +
                     "To apply the deltas manually, use the database administration tool, before doing a " +
                     "recompile of the workspace.".

        IF VALID-HANDLE(gshSessionManager) THEN
            RUN showMessages IN gshSessionManager (INPUT  cMessage,    /* message to display */
                INPUT  "INF":U,          /* error type */
                INPUT  "&OK":U,    /* button list */
                INPUT  "&OK":U,           /* default button */
                INPUT  "":U,       /* cancel button */
                INPUT  cTitle,     /* error window title */
                INPUT  NO,         /* display if empty */
                INPUT  ?,          /* container handle */
                OUTPUT cButton).   /* button pressed */
        ELSE
            /* Display the message with a normal message dialog  */
            MESSAGE
                cMessage
                VIEW-AS ALERT-BOX INFORMATION BUTTONS OK
                TITLE cTitle.
    END.

    /* Remove the actionUnderWay record for the import process. */
    IF VALID-HANDLE(gshSessionManager) THEN
        RUN getActionUnderway IN gshSessionManager (
            INPUT  "SCM":U,
            INPUT  "IMPORT":U,
            INPUT  gcRtbCurrentWorkspace,
            INPUT  "":U,
            INPUT  "":U,
            INPUT  YES,
            OUTPUT lImportUnderway).

    /* Write a closing comment to the import log file */
    ASSIGN
        cMessage = "[":U + STRING(TODAY) + " ":U + STRING(TIME, "HH:MM") + "] ":U +
                    "Import Processing Complete for workspace : ":U + gcRtbCurrentWorkspace + "~n":U
                    + "===============================================================":U.

    PUBLISH "logEvent" (INPUT pcEvent,
        INPUT cMessage,
        INPUT "":U,
        INPUT gcRtbCurrentWorkspace,
        INPUT gcRtbCurrentUser,
        INPUT "LOG":U,
        INPUT "dynrtb_import.LOG",
        INPUT "":U) .

    ASSIGN
        cMessage = "DO you want TO VIEW the IMPORT LOG file? ".

    MESSAGE
        cMessage
        VIEW-AS ALERT-BOX QUESTION
        BUTTONS YES-NO
        TITLE cMesWinTitle
        UPDATE lAnswer.


    IF lAnswer /*TRIM(cButton, "&":U) = "YES":U */ THEN
        IF SEARCH("rtb/w/rtb_txtviewer.w":U) <> ? OR
            SEARCH("rtb/w/rtb_txtviewer.r":U) <> ? THEN
            RUN rtb/w/rtb_txtviewer.w (INPUT SEARCH("dynrtb_import.LOG")).

    /* Check if the user wants to do a selective compile after the import process.                                       */
    /* Make sure the users is aware that there are no schema changes that need to be applied before running the compile. */
    ASSIGN
        cMessage = "Do you want to do a Selective Compile of this workspace? " + "~n":U +
                 "Selective compile will be run in batch and will not showing progress on the screen." + "~n":U + "~n":U +
                 "NOTE: IF this import process also included schema changes that need to be applied," + "~n":U +
                 "then it is not recommended to do a Selective Compile at this time." + "~n":U +
                 "A schema update should then be performed before compiling." + "~n":U + "~n":U +
                 "NOTE 2: The Selective compile process may take several minutes to start!" + "~n":U + "~n":U +
                 "Do you want to run the Selective Compile now?".

    /* Use a standard message box here, as we the text is too big and wide to fit in the standard ask question dialog box */
    MESSAGE
        cMessage
        VIEW-AS ALERT-BOX QUESTION
        BUTTONS YES-NO
        TITLE cTitle
        UPDATE lAnswer.

    IF lAnswer THEN
    DO:
        SESSION:SET-WAIT-STATE("GENERAL":U).

        IF NOT VALID-HANDLE(hCompiler) THEN
        DO:
            RUN VALUE("rtb/p/rtb_compiler.p") PERSISTENT SET hCompiler.
            IF VALID-HANDLE(hCompiler) THEN
                THIS-PROCEDURE:ADD-SUPER-PROCEDURE(hCompiler).
        END.

        IF gcRTBVersion BEGINS "11":U THEN
            RUN rtb_selective_compile IN hCompiler (
                INPUT gcRtbCurrentWorkspace,
                INPUT 0,
                INPUT "":U, /*Pmodule*/
                INPUT "":U, /*Pobj-group*/
                INPUT "":U, /*Pobj-type*/
                INPUT "":U, /*Pobject*/
                INPUT "":U, /*pcPmod */
                INPUT YES,  /*Pxref*/
                INPUT NO,   /*Plistingst*/
                INPUT NO,   /*Pforce*/
                INPUT NO,   /* task completion? */
                INPUT NO,   /* ignore warnings */
                INPUT NO,    /*PstopOnError*/
                INPUT NO).   /*plTaskRcode  */
        ELSE
            IF gcRTBVersion BEGINS "10":U THEN
                RUN rtb_selective_compile IN hCompiler (
                    INPUT gcRtbCurrentWorkspace,
                    INPUT 0,
                    INPUT "":U, /*Pmodule*/
                    INPUT "":U, /*Pobj-group*/
                    INPUT "":U, /*Pobj-type*/
                    INPUT "":U, /*Pobject*/
                    INPUT YES,  /*Pxref*/
                    INPUT NO,   /*Plistingst*/
                    INPUT NO,   /*Pforce*/
                    INPUT NO,   /* task completion? */
                    INPUT NO,   /* ignore warnings */
                    INPUT NO).    /*PstopOnError*/

        cCompileError = RETURN-VALUE.

        THIS-PROCEDURE:REMOVE-SUPER-PROCEDURE(hCompiler).
        DELETE PROCEDURE hCompiler.

        IF NUM-ENTRIES(cCompileError,CHR(1)) > 1 THEN
        DO:
            IF ENTRY(1,cCompileError,CHR(1)) EQ "INFO":U THEN
                pcErrorMessage = ENTRY(2,cCompileError,CHR(1)).
            ELSE
                pcErrorMessage = SUBSTITUTE("Warnings/Errors encountered." + "~n":U +
                    "See &1 for details.",
                    ENTRY(2,cCompileError,CHR(1))).
        END.
        ELSE
            IF pcErrorMessage = "Cancel":U THEN
                pcErrorMessage = "Selective compile cancelled.".

        /* Destroy status window if running */
        IF VALID-HANDLE(hStatusWin) THEN
        DO:
            RUN destroyObject IN hStatusWin.
            ASSIGN
                hStatusWin = ?.
        END.

        SESSION:SET-WAIT-STATE("":U).

        IF pcErrorMessage NE "":U THEN
            ASSIGN cMessage = pcErrorMessage.
        ELSE
            ASSIGN
                cMessage = "Selective Compile complete".

        IF VALID-HANDLE(gshSessionManager) THEN
            RUN showMessages IN gshSessionManager (INPUT  cMessage,   /* message to display */
                INPUT  "INF":U,    /* error type */
                INPUT  "&OK":U,    /* button list */
                INPUT  "&OK":U,    /* default button */
                INPUT  "":U,       /* cancel button */
                INPUT  cTitle,     /* error window title */
                INPUT  NO,         /* display if empty */
                INPUT  ?,          /* container handle */
                OUTPUT cButton).   /* button pressed */

        /* If there are errors during the compile, then show the contents of the log file in a
           procedure editor in the same way as RTB does */
        IF pcErrorMessage NE "":U THEN
            IF SEARCH("rtb/w/rtb_txtviewer.w":U) <> ? OR
                SEARCH("rtb/w/rtb_txtviewer.r":U) <> ? THEN
                RUN rtb/w/rtb_txtviewer.w (INPUT ENTRY(2,cCompileError,CHR(1))).
    END.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hData) THEN
            DELETE OBJECT hData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-processImportBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE processImportBefore Procedure
PROCEDURE processImportBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Before import
          Parameter :  pcContext       : ""
          / Meaning :  pcOther         : Workspace id importing into
                       pcErrorMessage : non blank will cancel

          Notes:       This procedure will be run automatically from Roundtable when an import is
                       started.

        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cMessage AS CHARACTER NO-UNDO.

    ASSIGN
        cMessage = "[":U + STRING(TODAY) + " ":U + STRING(TIME, "HH:MM") + "] ":U +
                    "Import Processing Begin for Workspace : ":U + gcRtbCurrentWorkspace.

    PUBLISH "logEvent" (INPUT pcEvent,
        INPUT cMessage,
        INPUT "":U,
        INPUT gcRtbCurrentWorkspace,
        INPUT gcRtbCurrentUser,
        INPUT "LOG":U,
        INPUT "dynrtb_import.log",
        INPUT "":U) .

    IF VALID-HANDLE(gshSessionManager) THEN
    DO:
        RUN setActionUnderway IN gshSessionManager
            (INPUT "SCM":U,
            INPUT "IMPORT":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT "":U,
            INPUT "":U).

        ASSIGN
            cMesWinTitle          = "Roundtable Import Control (Dynamics Enhancement)":U
            cMesWinButtonList     = "&Yes,&No":U
            cMesWinButtonDefault  = "&Yes":U
            cMesWinButtonCancel   = "&No":U
            cMesWinAnswerValue    = "":U
            cMesWinAnswerDataType = "":U
            cMesWinAnswerFormat   = "":U
            cMesWinMessage        = "If errors are encountered during the import processing, " +
                                "do you want to continue having messages shown in a message dialog, " +
                                "or have all subsequent messages written to the status window and log file?" + "~n":U + "~n":U +
                                "(Yes) - Show Messages / (No) - Suppress Messages".

        MESSAGE
            cMesWinMessage
            VIEW-AS ALERT-BOX QUESTION
            BUTTONS YES-NO-CANCEL
            TITLE cMesWinTitle
            UPDATE lAnswer AS LOGICAL.


        IF NOT lAnswer /*TRIM(cMesWinButtonPressed, "&":U) = "No" */ THEN
        DO:
            DYNAMIC-FUNCTION("setPropertyList":U IN gshSessionManager,
                INPUT "SuppressMessages",
                INPUT "YES":U,
                INPUT YES).
        END.
        ELSE
        DO:
            DYNAMIC-FUNCTION("setPropertyList":U IN gshSessionManager,
                INPUT "SuppressMessages",
                INPUT "NO":U,
                INPUT YES).
        END.
    END. /* IF VALID-HANDLE() ...*/

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-roundtableShutdown) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE roundtableShutdown Procedure
PROCEDURE roundtableShutdown :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters:   pcEvent          :   "roundtableShutdown",
                        pcContext        :
                        pcOther          :
                        ip_error_message  :   Ignored
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcErrorMessage    AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-roundtableStartup) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE roundtableStartup Procedure
PROCEDURE roundtableStartup :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters:   pcEvent          :   "roundtableStartup",
                        pcContext        :
                        pcOther          :
                        ip_error_message  :   Cancel if false

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    /* Get the appServer connection  */
    IF NOT VALID-HANDLE(ghRtbAs) THEN
        PUBLISH "evRtbCustSetRTBASConnection" (INPUT "":U).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCheckDCUWorkspaceLock) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCheckDCUWorkspaceLock Procedure
PROCEDURE scmCheckDCUWorkspaceLock :
    /*------------------------------------------------------------------------------
            Purpose:
            Parameters: <none>
            Notes:
     ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcWorkspace   AS CHARACTER   NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError       AS CHARACTER   NO-UNDO.

    DEFINE VARIABLE cWSLockedBy AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hData       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWSBuf      AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs) THEN
        PUBLISH  "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF VALID-HANDLE(ghRtbAs) THEN
    DO:
        /* Get the workspace record */
        hData = oRtbProxyHelper:rtbGetWorkspaceHandle(pcWorkspace).

        IF VALID-HANDLE(hData) THEN
        DO:
            hWSBuf = hData:DEFAULT-BUFFER-HANDLE.
            hWSBuf:FIND-FIRST() NO-ERROR.
            IF hWSBUf:AVAILABLE THEN
            DO:
                ASSIGN
                    cWSLockedBy = hWSBuf::locked-by.
                IF INDEX(cWSLockedBy, "DCU":U) > 0 THEN
                DO:
                    ASSIGN
                        pcError = "The Dynamics environment has not been started. The workspace is locked : " + "~n" +
                         "'" + cWSLockedBy + "'" + "~n":U + "~n":U +
                         "Access to the workspace is limited as the integration hooks between RTB" + "~n":U +
                         "and Dynamics are not enabled. " + "~n":U + "~n":U +
                         "WAIT until the DCU upgrade has been completed and re-select the workspace, " + "~n":U +
                         "or contact your system administrator for further information.".
                END.
            END.
        END.
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        /* Clean up */
        IF VALID-HANDLE(hData) THEN
            DELETE OBJECT hData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-session-shutdown) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE session-shutdown Procedure
PROCEDURE session-shutdown :
    /*------------------------------------------------------------------------------
          Purpose:
          Parameters:   pcEvent          :   "SESSION-SHUTDOWN",
                        pcContext        :
                        pcOther          :
                        ip_error_message  :   Ignored
          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-updateSchema) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateSchema Procedure
PROCEDURE updateSchema :
    /*------------------------------------------------------------------------------
          Purpose:     Update Schema
          Parameter :  pcContext       : ""
                       pcOther         : Workspace id
                       pcErrorMessage : Ignored

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-updateSchemaBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateSchemaBefore Procedure
PROCEDURE updateSchemaBefore :
    /*------------------------------------------------------------------------------
          Purpose:     Update Schema Before
          Parameter :  pcContext       : ""
                       pcOther         : Workspace id
                       pcErrorMessage : non blank will cancel (logical - false will cancel schema update)

          Notes:
        ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-writeDeployPropsFile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE writeDeployPropsFile Procedure
PROCEDURE writeDeployPropsFile :
    /*------------------------------------------------------------------------------
            Purpose: Write the deployment properties to a rtbdeploy.props file
            Parameters: <none>
            Notes: The rtbdeploy.props file will be used for batch deployment processing.
        ------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER  prDeployRowid AS ROWID  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError       AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE cDeploymentDir       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cDeploymentRootDir   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cDeployPropsFile     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cDeployPropsRootFile AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cDeploymentList      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lSchemaIncluded      AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE hDsSchupd            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cError               AS CHARACTER NO-UNDO.

    DEFINE BUFFER Brtb_deploy  FOR rtb_deploy.
    DEFINE BUFFER B2rtb_deploy FOR rtb_deploy.

    FIND FIRST Brtb_deploy WHERE ROWID(Brtb_deploy) = prDeployRowid NO-LOCK NO-ERROR.

    IF AVAILABLE Brtb_deploy THEN
    DO:
        PUBLISH "evRtbSetStatusMessage":U (INPUT "Creating rtbdeploy.props file...").

        /* Get a list of the deployments that have been created for this site */
        FOR EACH B2rtb_deploy NO-LOCK WHERE
            B2rtb_deploy.site-code = Brtb_deploy.site-code AND
            B2rtb_deploy.wspace-id = Brtb_deploy.wspace-id BY B2rtb_deploy.deploy-sequence:

            ASSIGN
                cDeploymentDir     = ENTRY(1,B2rtb_deploy.directory)
                cDeploymentRootDir = SUBSTRING(cDeploymentDir, 1, R-INDEX(cDeploymentDir, "/":U))
                cDeploymentDir     = SUBSTRING(ENTRY(1, B2rtb_deploy.directory), R-INDEX(B2rtb_deploy.directory, "/":U) + 1).

            ASSIGN
                cDeploymentList = cDeploymentList + (IF cDeploymentList NE "":U THEN ",":U ELSE "":U) + cDeploymentDir.
        END.

        hDsSchupd = oRtbProxyHelper:rtbgetSchemaUpdateList (
            INPUT  gcRtbCurrentWorkspace,
            INPUT  Brtb_deploy.site-code).

        IF VALID-HANDLE(hDsSchupd) THEN
            ASSIGN
                lSchemaIncluded = TRUE.
        ELSE
            ASSIGN
                lSchemaIncluded = FALSE.

        /* Now work out the deployment dir and root dir for the current deployment */
        ASSIGN
            cDeploymentDir       = ENTRY(1,Brtb_deploy.directory)
            cDeploymentRootDir   = SUBSTRING(cDeploymentDir, 1, R-INDEX(cDeploymentDir, "/":U))
            cDeployPropsFile     = cDeploymentDir + "/rtb_idat/rtbdeploy.props":U
            cDeployPropsRootFile = cDeploymentRootDir + "/rtbdeploy.props":U.

        /* Write the rtbdeploy.props file  */
        OUTPUT TO VALUE(cDeployPropsFile).
        PUT UNFORMATTED
            "# Rountable deployment properties file" SKIP.
        PUT UNFORMATTED
            "rtb.deploy.workspace=" Brtb_deploy.wspace-id SKIP.
        PUT UNFORMATTED
            "rtb.deploy.site-code=" Brtb_deploy.site-code SKIP.
        PUT UNFORMATTED
            "rtb.deploy.deploy-sequence=" Brtb_deploy.deploy-sequence SKIP.
        IF NUM-ENTRIES(Brtb_deploy.directory) > 1 THEN
            PUT UNFORMATTED "rtb.deploy.dir=" SUBSTRING(ENTRY(1, Brtb_deploy.directory), R-INDEX(Brtb_deploy.directory, "/":U) + 1) SKIP.
        ELSE
            PUT UNFORMATTED "rtb.deploy.dir=" SUBSTRING(Brtb_deploy.directory, R-INDEX(Brtb_deploy.directory, "/":U) + 1) SKIP.
        PUT UNFORMATTED
            "rtb.deploy.release-num=" Brtb_deploy.release-num SKIP.
        PUT UNFORMATTED "rtb.deploy.deploy-list=" + cDeploymentList SKIP.
        PUT UNFORMATTED "rtb.deploy.schema-included=" + STRING(lSchemaIncluded).
        OUTPUT CLOSE.

        /* Check that we created a file, and if we did, then copy this to the deployment root directory */
        FILE-INFORMATION:FILE-NAME = cDeployPropsFile.
        cDeployPropsFile = FILE-INFORMATION:FULL-PATHNAME.
        IF cDeployPropsFile NE ? AND cDeployPropsFile NE "":U THEN
        DO:
            OS-COPY VALUE(cDeployPropsFile) VALUE(cDeployPropsRootFile).

            PUBLISH "evRtbSetStatusMessage":U (INPUT cDeployPropsFile + " created.").
            PROCESS EVENTS.
        END.
        ELSE
            ASSIGN pcError = "Deployment property file" + cDeployPropsFile + " was not created.".
    END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF



/* ************************  Function Implementations ***************** */
&IF DEFINED(EXCLUDE-getTimeStampString) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getTimeStampString Version
FUNCTION getTimeStampString RETURNS CHARACTER (
    INPUT pcEvent       AS CHARACTER,
    INPUT pcWorkspaceid AS CHARACTER,
    INPUT pcRtbUserId   AS CHARACTER):

    DEFINE VARIABLE cTimeStampString AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cEventText       AS CHARACTER NO-UNDO.

    CASE pcEvent:
        WHEN "addObject":U THEN
            ASSIGN
                cEventText       = "[Object created] "
                cTimeStampString = SUBSTITUTE("&1&2 &3:~n", cEventText, STRING(NOW, "99/99/9999 HH:MM:SS+HH:MM"), pcRtbUserId).
        WHEN "createObjectVariant":U THEN
            ASSIGN
                cEventText       = "[Object variant created] "
                cTimeStampString = SUBSTITUTE("&1&2 &3:~n", cEventText, STRING(NOW, "99/99/9999 HH:MM:SS+HH:MM"), pcRtbUserId).
        WHEN "checkOutObject":U THEN
            ASSIGN
                cEventText       = "[Object checked out] "
                cTimeStampString = SUBSTITUTE("&1&2 &3:~n", cEventText, STRING(NOW, "99/99/9999 HH:MM:SS+HH:MM"), pcRtbUserId).
        WHEN "checkInObject":U THEN
            ASSIGN
                cEventText       = SUBSTITUTE("~n[Object checked in by &1] ", pcRtbUserId)
                cTimeStampString = SUBSTITUTE("&1&2", cEventText, STRING(NOW, "99/99/9999 HH:MM:SS+HH:MM")).
    END CASE.

    IF cTimeStampString = "":U THEN
        ASSIGN
            cTimeStampString = SUBSTITUTE("&1", STRING(NOW, "99/99/9999 HH:MM:SS+HH:MM")).

    RETURN cTimeStampString.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF



